/*===========================================================================*/
/*   (Engine/compiler.scm)                                                   */
/*   Bigloo (2.6b)                                                           */
/*   Inria -- Sophia Antipolis (c)       Mon Dec 15 12:14:36 CET 2003        */
/*===========================================================================*/
/* COMPILATION: (/users/serrano/prgm/project/bigloo/bin/bigloo -q -afile .afile -fsharing -fno-reflection -cc gcc-2.95 -lib-dir /users/serrano/prgm/project/bigloo/lib/2.6b -unsafev -no-hello -O2 -rm -unsafe -s -indent Engine/compiler.scm)*/
/* GC selection */
#define THE_GC BOEHM_GC

#include <bigloo.h>


/* Object type definitions */
typedef struct BgL_typez00_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_idz00;
   obj_t BgL_namez00;
   obj_t BgL_siza7eza7;
   obj_t BgL_classz00;
   obj_t BgL_coercezd2tozd2;
   obj_t BgL_parentsz00;
   bool_t BgL_initzf3zf3;
   bool_t BgL_magiczf3zf3;
   obj_t BgL_z42z42;
   obj_t BgL_aliasz00;
   obj_t BgL_pointedzd2tozd2byz00;
   obj_t BgL_tvectorz00;
   obj_t BgL_locationz00;
   obj_t BgL_importzd2locationzd2;
} *BgL_typez00_bglt;

typedef struct BgL_valuez00_bgl {
   header_t header;
   obj_t widening;
} *BgL_valuez00_bglt;

typedef struct BgL_variablez00_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_idz00;
   obj_t BgL_namez00;
   struct BgL_typez00_bgl * BgL_typez00;
   struct BgL_valuez00_bgl * BgL_valuez00;
   obj_t BgL_accessz00;
   obj_t BgL_fastzd2alphazd2;
   obj_t BgL_removablez00;
   long BgL_occurrencez00;
} *BgL_variablez00_bglt;

typedef struct BgL_globalz00_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_idz00;
   obj_t BgL_namez00;
   struct BgL_typez00_bgl * BgL_typez00;
   struct BgL_valuez00_bgl * BgL_valuez00;
   obj_t BgL_accessz00;
   obj_t BgL_fastzd2alphazd2;
   obj_t BgL_removablez00;
   long BgL_occurrencez00;
   obj_t BgL_modulez00;
   obj_t BgL_importz00;
   bool_t BgL_evaluablezf3zf3;
   bool_t BgL_libraryzf3zf3;
   bool_t BgL_userzf3zf3;
   obj_t BgL_pragmaz00;
   obj_t BgL_srcz00;
   obj_t BgL_jvmzd2typezd2namez00;
} *BgL_globalz00_bglt;

typedef struct BgL_localz00_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_idz00;
   obj_t BgL_namez00;
   struct BgL_typez00_bgl * BgL_typez00;
   struct BgL_valuez00_bgl * BgL_valuez00;
   obj_t BgL_accessz00;
   obj_t BgL_fastzd2alphazd2;
   obj_t BgL_removablez00;
   long BgL_occurrencez00;
   bool_t BgL_userzf3zf3;
   long BgL_keyz00;
} *BgL_localz00_bglt;

typedef struct BgL_funz00_bgl {
   header_t header;
   obj_t widening;
   long BgL_arityz00;
   obj_t BgL_sidezd2effectzf3z21;
   obj_t BgL_predicatezd2ofzd2;
   obj_t BgL_stackzd2allocatorzd2;
   bool_t BgL_topzf3zf3;
   obj_t BgL_thezd2closurezd2;
   obj_t BgL_effectz00;
} *BgL_funz00_bglt;

typedef struct BgL_sfunz00_bgl {
   header_t header;
   obj_t widening;
   long BgL_arityz00;
   obj_t BgL_sidezd2effectzf3z21;
   obj_t BgL_predicatezd2ofzd2;
   obj_t BgL_stackzd2allocatorzd2;
   bool_t BgL_topzf3zf3;
   obj_t BgL_thezd2closurezd2;
   obj_t BgL_effectz00;
   obj_t BgL_propertyz00;
   obj_t BgL_argsz00;
   obj_t BgL_bodyz00;
   obj_t BgL_classz00;
   obj_t BgL_dssslzd2keywordszd2;
   obj_t BgL_locz00;
} *BgL_sfunz00_bglt;

typedef struct BgL_cfunz00_bgl {
   header_t header;
   obj_t widening;
   long BgL_arityz00;
   obj_t BgL_sidezd2effectzf3z21;
   obj_t BgL_predicatezd2ofzd2;
   obj_t BgL_stackzd2allocatorzd2;
   bool_t BgL_topzf3zf3;
   obj_t BgL_thezd2closurezd2;
   obj_t BgL_effectz00;
   obj_t BgL_argszd2typezd2;
   bool_t BgL_macrozf3zf3;
   bool_t BgL_infixzf3zf3;
   obj_t BgL_methodz00;
} *BgL_cfunz00_bglt;

typedef struct BgL_svarz00_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_locz00;
} *BgL_svarz00_bglt;

typedef struct BgL_scnstz00_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_nodez00;
   obj_t BgL_classz00;
   obj_t BgL_locz00;
} *BgL_scnstz00_bglt;

typedef struct BgL_cvarz00_bgl {
   header_t header;
   obj_t widening;
   bool_t BgL_macrozf3zf3;
} *BgL_cvarz00_bglt;

typedef struct BgL_sexitz00_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_handlerz00;
   bool_t BgL_detachedzf3zf3;
} *BgL_sexitz00_bglt;

typedef struct BgL_feffectz00_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_readz00;
   obj_t BgL_writez00;
} *BgL_feffectz00_bglt;

typedef struct BgL_nodez00_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_locz00;
   struct BgL_typez00_bgl * BgL_typez00;
} *BgL_nodez00_bglt;

typedef struct BgL_nodezf2effectzf2_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_locz00;
   struct BgL_typez00_bgl * BgL_typez00;
   obj_t BgL_sidezd2effectzf3z21;
   obj_t BgL_keyz00;
} *BgL_nodezf2effectzf2_bglt;

typedef struct BgL_atomz00_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_locz00;
   struct BgL_typez00_bgl * BgL_typez00;
   obj_t BgL_valuez00;
} *BgL_atomz00_bglt;

typedef struct BgL_varz00_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_locz00;
   struct BgL_typez00_bgl * BgL_typez00;
   struct BgL_variablez00_bgl * BgL_variablez00;
} *BgL_varz00_bglt;

typedef struct BgL_closurez00_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_locz00;
   struct BgL_typez00_bgl * BgL_typez00;
   struct BgL_variablez00_bgl * BgL_variablez00;
} *BgL_closurez00_bglt;

typedef struct BgL_kwotez00_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_locz00;
   struct BgL_typez00_bgl * BgL_typez00;
   obj_t BgL_valuez00;
} *BgL_kwotez00_bglt;

typedef struct BgL_sequencez00_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_locz00;
   struct BgL_typez00_bgl * BgL_typez00;
   obj_t BgL_sidezd2effectzf3z21;
   obj_t BgL_keyz00;
   obj_t BgL_nodesz00;
} *BgL_sequencez00_bglt;

typedef struct BgL_appz00_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_locz00;
   struct BgL_typez00_bgl * BgL_typez00;
   obj_t BgL_sidezd2effectzf3z21;
   obj_t BgL_keyz00;
   struct BgL_varz00_bgl * BgL_funz00;
   obj_t BgL_argsz00;
} *BgL_appz00_bglt;

typedef struct BgL_appzd2lyzd2_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_locz00;
   struct BgL_typez00_bgl * BgL_typez00;
   struct BgL_nodez00_bgl * BgL_funz00;
   struct BgL_nodez00_bgl * BgL_argz00;
} *BgL_appzd2lyzd2_bglt;

typedef struct BgL_funcallz00_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_locz00;
   struct BgL_typez00_bgl * BgL_typez00;
   struct BgL_nodez00_bgl * BgL_funz00;
   obj_t BgL_argsz00;
   obj_t BgL_strengthz00;
} *BgL_funcallz00_bglt;

typedef struct BgL_externz00_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_locz00;
   struct BgL_typez00_bgl * BgL_typez00;
   obj_t BgL_sidezd2effectzf3z21;
   obj_t BgL_keyz00;
   obj_t BgL_exprza2za2;
   obj_t BgL_effectz00;
} *BgL_externz00_bglt;

typedef struct BgL_pragmaz00_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_locz00;
   struct BgL_typez00_bgl * BgL_typez00;
   obj_t BgL_sidezd2effectzf3z21;
   obj_t BgL_keyz00;
   obj_t BgL_exprza2za2;
   obj_t BgL_effectz00;
   obj_t BgL_formatz00;
} *BgL_pragmaz00_bglt;

typedef struct BgL_getfieldz00_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_locz00;
   struct BgL_typez00_bgl * BgL_typez00;
   obj_t BgL_sidezd2effectzf3z21;
   obj_t BgL_keyz00;
   obj_t BgL_exprza2za2;
   obj_t BgL_effectz00;
   obj_t BgL_fnamez00;
   struct BgL_typez00_bgl * BgL_ftypez00;
   struct BgL_typez00_bgl * BgL_otypez00;
} *BgL_getfieldz00_bglt;

typedef struct BgL_setfieldz00_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_locz00;
   struct BgL_typez00_bgl * BgL_typez00;
   obj_t BgL_sidezd2effectzf3z21;
   obj_t BgL_keyz00;
   obj_t BgL_exprza2za2;
   obj_t BgL_effectz00;
   obj_t BgL_fnamez00;
   struct BgL_typez00_bgl * BgL_ftypez00;
   struct BgL_typez00_bgl * BgL_otypez00;
} *BgL_setfieldz00_bglt;

typedef struct BgL_newz00_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_locz00;
   struct BgL_typez00_bgl * BgL_typez00;
   obj_t BgL_sidezd2effectzf3z21;
   obj_t BgL_keyz00;
   obj_t BgL_exprza2za2;
   obj_t BgL_effectz00;
} *BgL_newz00_bglt;

typedef struct BgL_vallocz00_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_locz00;
   struct BgL_typez00_bgl * BgL_typez00;
   obj_t BgL_sidezd2effectzf3z21;
   obj_t BgL_keyz00;
   obj_t BgL_exprza2za2;
   obj_t BgL_effectz00;
   obj_t BgL_czd2heapzd2formatz00;
   struct BgL_typez00_bgl * BgL_ftypez00;
   struct BgL_typez00_bgl * BgL_otypez00;
} *BgL_vallocz00_bglt;

typedef struct BgL_vrefz00_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_locz00;
   struct BgL_typez00_bgl * BgL_typez00;
   obj_t BgL_sidezd2effectzf3z21;
   obj_t BgL_keyz00;
   obj_t BgL_exprza2za2;
   obj_t BgL_effectz00;
   obj_t BgL_czd2formatzd2;
   struct BgL_typez00_bgl * BgL_ftypez00;
   struct BgL_typez00_bgl * BgL_otypez00;
   struct BgL_typez00_bgl * BgL_vtypez00;
} *BgL_vrefz00_bglt;

typedef struct BgL_vsetz12z12_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_locz00;
   struct BgL_typez00_bgl * BgL_typez00;
   obj_t BgL_sidezd2effectzf3z21;
   obj_t BgL_keyz00;
   obj_t BgL_exprza2za2;
   obj_t BgL_effectz00;
   obj_t BgL_czd2formatzd2;
   struct BgL_typez00_bgl * BgL_ftypez00;
   struct BgL_typez00_bgl * BgL_otypez00;
   struct BgL_typez00_bgl * BgL_vtypez00;
} *BgL_vsetz12z12_bglt;

typedef struct BgL_vlengthz00_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_locz00;
   struct BgL_typez00_bgl * BgL_typez00;
   obj_t BgL_sidezd2effectzf3z21;
   obj_t BgL_keyz00;
   obj_t BgL_exprza2za2;
   obj_t BgL_effectz00;
   obj_t BgL_czd2formatzd2;
   struct BgL_typez00_bgl * BgL_vtypez00;
} *BgL_vlengthz00_bglt;

typedef struct BgL_isaz00_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_locz00;
   struct BgL_typez00_bgl * BgL_typez00;
   obj_t BgL_sidezd2effectzf3z21;
   obj_t BgL_keyz00;
   obj_t BgL_exprza2za2;
   obj_t BgL_effectz00;
   struct BgL_typez00_bgl * BgL_classz00;
} *BgL_isaz00_bglt;

typedef struct BgL_castz00_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_locz00;
   struct BgL_typez00_bgl * BgL_typez00;
   struct BgL_nodez00_bgl * BgL_argz00;
} *BgL_castz00_bglt;

typedef struct BgL_setqz00_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_locz00;
   struct BgL_typez00_bgl * BgL_typez00;
   struct BgL_varz00_bgl * BgL_varz00;
   struct BgL_nodez00_bgl * BgL_valuez00;
} *BgL_setqz00_bglt;

typedef struct BgL_conditionalz00_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_locz00;
   struct BgL_typez00_bgl * BgL_typez00;
   obj_t BgL_sidezd2effectzf3z21;
   obj_t BgL_keyz00;
   struct BgL_nodez00_bgl * BgL_testz00;
   struct BgL_nodez00_bgl * BgL_truez00;
   struct BgL_nodez00_bgl * BgL_falsez00;
} *BgL_conditionalz00_bglt;

typedef struct BgL_failz00_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_locz00;
   struct BgL_typez00_bgl * BgL_typez00;
   struct BgL_nodez00_bgl * BgL_procz00;
   struct BgL_nodez00_bgl * BgL_msgz00;
   struct BgL_nodez00_bgl * BgL_objz00;
} *BgL_failz00_bglt;

typedef struct BgL_selectz00_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_locz00;
   struct BgL_typez00_bgl * BgL_typez00;
   obj_t BgL_sidezd2effectzf3z21;
   obj_t BgL_keyz00;
   struct BgL_nodez00_bgl * BgL_testz00;
   obj_t BgL_clausesz00;
   struct BgL_typez00_bgl * BgL_itemzd2typezd2;
} *BgL_selectz00_bglt;

typedef struct BgL_letzd2funzd2_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_locz00;
   struct BgL_typez00_bgl * BgL_typez00;
   obj_t BgL_sidezd2effectzf3z21;
   obj_t BgL_keyz00;
   obj_t BgL_localsz00;
   struct BgL_nodez00_bgl * BgL_bodyz00;
} *BgL_letzd2funzd2_bglt;

typedef struct BgL_letzd2varzd2_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_locz00;
   struct BgL_typez00_bgl * BgL_typez00;
   obj_t BgL_sidezd2effectzf3z21;
   obj_t BgL_keyz00;
   obj_t BgL_bindingsz00;
   struct BgL_nodez00_bgl * BgL_bodyz00;
   bool_t BgL_removablezf3zf3;
} *BgL_letzd2varzd2_bglt;

typedef struct BgL_setzd2exzd2itz00_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_locz00;
   struct BgL_typez00_bgl * BgL_typez00;
   struct BgL_varz00_bgl * BgL_varz00;
   struct BgL_nodez00_bgl * BgL_bodyz00;
} *BgL_setzd2exzd2itz00_bglt;

typedef struct BgL_jumpzd2exzd2itz00_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_locz00;
   struct BgL_typez00_bgl * BgL_typez00;
   struct BgL_nodez00_bgl * BgL_exitz00;
   struct BgL_nodez00_bgl * BgL_valuez00;
} *BgL_jumpzd2exzd2itz00_bglt;

typedef struct BgL_makezd2boxzd2_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_locz00;
   struct BgL_typez00_bgl * BgL_typez00;
   obj_t BgL_sidezd2effectzf3z21;
   obj_t BgL_keyz00;
   struct BgL_nodez00_bgl * BgL_valuez00;
} *BgL_makezd2boxzd2_bglt;

typedef struct BgL_boxzd2refzd2_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_locz00;
   struct BgL_typez00_bgl * BgL_typez00;
   obj_t BgL_sidezd2effectzf3z21;
   obj_t BgL_keyz00;
   struct BgL_varz00_bgl * BgL_varz00;
} *BgL_boxzd2refzd2_bglt;

typedef struct BgL_boxzd2setz12zc0_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_locz00;
   struct BgL_typez00_bgl * BgL_typez00;
   struct BgL_varz00_bgl * BgL_varz00;
   struct BgL_nodez00_bgl * BgL_valuez00;
} *BgL_boxzd2setz12zc0_bglt;

typedef struct BgL_ccompz00_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_idz00;
   obj_t BgL_producerz00;
   obj_t BgL_consumerz00;
   obj_t BgL_finaliza7erza7;
} *BgL_ccompz00_bglt;


extern obj_t BGl_coercezd2walkz12zc0zzcoerce_walkz00(obj_t);
extern obj_t BGl_loadzd2libraryzd2initz00zzinit_setrcz00();
extern obj_t BGl_za2optimzd2unrollzd2loopzf3za2zf3zzengine_paramz00;
extern obj_t BGl_modulezd2checksumzd2objectz00zzmodule_modulez00();
BGL_IMPORT double BGl_roundflz00zz__r4_numbers_6_5_flonumz00(double);
static obj_t BGl_methodzd2initzd2zzengine_compilerz00();
extern obj_t BGl_initializa7ezd2Genvz12z67zzast_envz00();
static obj_t BGl_zc3anonymousza33038ze3z83zzengine_compilerz00(obj_t);
extern obj_t BGl_writezd2effectzd2zzeffect_walkz00(obj_t);
BGL_IMPORT obj_t open_input_string(obj_t);
static obj_t BGl_zc3anonymousza32941ze3z83zzengine_compilerz00(obj_t);
extern obj_t BGl_bdbzd2walkz12zc0zzbdb_walkz00(obj_t);
extern obj_t BGl_installzd2compilerzd2signalsz12z12zzengine_signalsz00();
BGL_IMPORT obj_t BGl_readz00zz__readerz00(obj_t);
static obj_t BGl_zc3anonymousza32949ze3z83zzengine_compilerz00(obj_t);
static obj_t BGl_zc3anonymousza33049ze3z83zzengine_compilerz00(obj_t);
extern obj_t BGl_userzd2walkzd2zzuser_userz00(obj_t);
extern obj_t BGl_buildzd2astzd2zzast_buildz00(obj_t);
extern obj_t BGl_dumpzd2additionalzd2heapsz00zzheap_restorez00();
extern obj_t BGl_za2compilerzd2debugza2zd2zzengine_paramz00;
BGL_IMPORT obj_t string_to_bstring(char *);
static obj_t BGl_zc3anonymousza32957ze3z83zzengine_compilerz00(obj_t);
extern obj_t BGl_integratezd2walkz12zc0zzintegrate_walkz00(obj_t);
static obj_t BGl_zc3anonymousza33060ze3z83zzengine_compilerz00(obj_t);
extern obj_t BGl_za2targetzd2languageza2zd2zzengine_paramz00;
extern obj_t BGl_installzd2typezd2cachez12z12zztype_cachez00();
extern obj_t BGl_failzd2walkz12zc0zzfail_walkz00(obj_t);
extern obj_t BGl_bdbzd2settingz12zc0zzbdb_settingz00();
static obj_t BGl_zc3anonymousza33065ze3z83zzengine_compilerz00(obj_t);
static obj_t BGl_zc3anonymousza32966ze3z83zzengine_compilerz00(obj_t);
extern obj_t BGl_za2libzd2modeza2zd2zzengine_paramz00;
static obj_t BGl_zc3anonymousza33070ze3z83zzengine_compilerz00(obj_t);
extern obj_t BGl_installzd2initialzd2expanderz00zzexpand_installz00();
extern obj_t BGl_expandzd2unitszd2zzexpand_epsz00(obj_t);
extern obj_t BGl_za2bdbzd2debugza2zd2zzengine_paramz00;
static obj_t BGl_cnstzd2initzd2zzengine_compilerz00();
extern obj_t BGl_unitzd2sexpza2zd2addz12zb0zzast_unitz00(obj_t, obj_t);
extern obj_t BGl_producezd2modulez12zc0zzmodule_modulez00(obj_t);
static obj_t BGl_zc3anonymousza32975ze3z83zzengine_compilerz00(obj_t);
extern obj_t BGl_readzd2accesszd2filez00zzread_accessz00();
static obj_t BGl_zc3anonymousza32841ze3z83zzengine_compilerz00(obj_t);
static obj_t BGl_zc3anonymousza33078ze3z83zzengine_compilerz00(obj_t);
extern obj_t BGl_writezd2astzd2zzwrite_astz00(obj_t);
extern obj_t BGl_za2nbzd2errorzd2onzd2passza2zd2zztools_errorz00;
BGL_IMPORT obj_t BGl_displayzd22zd2zz__r4_output_6_10_3z00(obj_t, obj_t);
extern obj_t BGl_hellozd2worldzd2zzengine_enginez00();
extern obj_t BGl_za2currentzd2passza2zd2zzengine_passz00;
extern obj_t BGl_makezd2profzd2unitz00zzprof_walkz00();
static obj_t BGl_importedzd2moduleszd2initz00zzengine_compilerz00();
static obj_t BGl_zc3anonymousza33083ze3z83zzengine_compilerz00(obj_t);
static obj_t BGl_zc3anonymousza32984ze3z83zzengine_compilerz00(obj_t);
extern obj_t BGl_cnstzd2walkz12zc0zzcnst_walkz00(obj_t);
static obj_t BGl_zc3anonymousza32850ze3z83zzengine_compilerz00(obj_t);
static obj_t BGl_zc3anonymousza32990ze3z83zzengine_compilerz00(obj_t);
BGL_IMPORT obj_t BGl_exitz00zz__errorz00(obj_t);
static obj_t BGl_zc3anonymousza32856ze3z83zzengine_compilerz00(obj_t);
extern obj_t BGl_writezd2expandedzd2zzwrite_expandedz00(obj_t);
extern obj_t BGl_globaliza7ezd2walkz12z67zzglobaliza7e_walkza7(obj_t, obj_t);
extern obj_t BGl_za2callzf2cczf3za2z01zzengine_paramz00;
static obj_t BGl_toplevelzd2initzd2zzengine_compilerz00();
extern obj_t BGl_dotnetzd2ldzd2zzdotnet_ldz00();
BGL_IMPORT bool_t BGl_2ze3ze3zz__r4_numbers_6_5z00(obj_t, obj_t);
BGL_EXPORTED_DECL obj_t BGl_modulezd2initializa7ationz75zzengine_compilerz00(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zztools_speekz00(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zztools_errorz00(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zzengine_passz00(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zzengine_signalsz00(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zzengine_paramz00(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zzengine_enginez00(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zzread_srcz00(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zzwrite_expandedz00(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zzwrite_astz00(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zzread_accessz00(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zzread_jvmz00(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zzheap_restorez00(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zzheap_makez00(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zzast_envz00(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zzast_checkzd2sharingzd2(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zztype_typez00(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zzast_varz00(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zzast_nodez00(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zzast_buildz00(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zzast_unitz00(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zzast_checkzd2globalzd2initz00(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zzuser_userz00(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zztype_envz00(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zztype_cachez00(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zzmodule_modulez00(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zzmodule_includez00(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zzexpand_epsz00(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zzexpand_installz00(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zzinit_mainz00(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zzinit_setrcz00(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zztrace_walkz00(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zzinline_walkz00(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zzeffect_walkz00(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zzcallcc_walkz00(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zzfail_walkz00(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zzglobaliza7e_walkza7(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zzcfa_walkz00(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zzcfa_tvectorz00(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zzintegrate_walkz00(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zzcoerce_walkz00(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zzreduce_walkz00(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zzcnst_walkz00(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zzcgen_walkz00(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zzhgen_walkz00(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zzbdb_settingz00(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zzbdb_spreadzd2objzd2(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zzbdb_walkz00(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zzprof_walkz00(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zzcc_indentz00(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zzcc_ccz00(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zzcc_ldz00(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zzbackend_walkz00(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zzjvm_jdumpz00(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zzjvm_ldz00(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zzdotnet_dotnetz00(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zzdotnet_ldz00(long, char *);
BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__errorz00(long, char *);
BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__readerz00(long, char *);
BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__r4_equivalence_6_2z00(long, char *);
BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__r4_pairs_and_lists_6_3z00(long, char *);
BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__r4_numbers_6_5z00(long, char *);
BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__r4_numbers_6_5_flonumz00(long, char *);
BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__r4_output_6_10_3z00(long, char *);
static obj_t BGl_zc3anonymousza32864ze3z83zzengine_compilerz00(obj_t);
extern obj_t BGl_userzd2errorzd2zztools_errorz00(obj_t, obj_t, obj_t, obj_t);
extern obj_t BGl_stopzd2onzd2passz00zzengine_passz00(obj_t, obj_t);
extern obj_t BGl_effectzd2walkz12zc0zzeffect_walkz00(obj_t, bool_t);
extern obj_t BGl_reducezd2walkz12zc0zzreduce_walkz00(obj_t);
static obj_t BGl_zc3anonymousza32871ze3z83zzengine_compilerz00(obj_t);
extern obj_t BGl_checkzd2globalzd2initializa7ationza7zzast_checkzd2globalzd2initz00();
extern obj_t BGl_readzd2jfilezd2zzread_jvmz00();
extern obj_t BGl_checkzd2typeszd2zztype_envz00();
extern obj_t BGl_tracezd2walkz12zc0zztrace_walkz00(obj_t);
extern obj_t BGl_cfazd2walkz12zc0zzcfa_walkz00(obj_t);
extern obj_t BGl_jvmzd2dumpzd2zzjvm_jdumpz00(obj_t);
static obj_t BGl_zc3anonymousza32880ze3z83zzengine_compilerz00(obj_t);
extern obj_t BGl_setzd2defaultzd2typez12z12zztype_cachez00(BgL_typez00_bglt);
extern obj_t BGl_makezd2addzd2heapz00zzheap_makez00();
BGL_IMPORT obj_t BGl_memqz00zz__r4_pairs_and_lists_6_3z00(obj_t, obj_t);
extern obj_t BGl_bdbzd2spreadzd2objz12z12zzbdb_spreadzd2objzd2(obj_t);
extern obj_t BGl_enginez00zzengine_enginez00();
extern obj_t BGl_restorezd2heapzd2zzheap_restorez00();
extern obj_t BGl_getzd2toplevelzd2unitz00zzmodule_includez00();
extern obj_t BGl_za2optimza2z00zzengine_paramz00;
static obj_t BGl_zc3anonymousza32752ze3z83zzengine_compilerz00(obj_t);
extern obj_t BGl_za2heapzd2debugza2zd2zzengine_paramz00;
BGL_EXPORTED_DECL obj_t BGl_compilerz00zzengine_compilerz00();
extern obj_t BGl_initializa7ezd2Tenvz12z67zztype_envz00();
extern obj_t BGl_inlinezd2walkz12zc0zzinline_walkz00(obj_t, obj_t);
extern obj_t BGl_za2sawza2z00zzengine_paramz00;
BGL_IMPORT obj_t display_string(obj_t, obj_t);
static obj_t BGl_zc3anonymousza33003ze3z83zzengine_compilerz00(obj_t);
extern obj_t BGl_za2passza2z00zzengine_paramz00;
extern obj_t BGl_jvmzd2ldzd2zzjvm_ldz00();
static obj_t BGl_zc3anonymousza32904ze3z83zzengine_compilerz00(obj_t);
extern obj_t BGl_internalzd2errorzd2zztools_errorz00(obj_t, obj_t, obj_t);
extern obj_t BGl_patchzd2vectorzd2setz12z12zzcfa_tvectorz00();
static obj_t BGl_zc3anonymousza32896ze3z83zzengine_compilerz00(obj_t);
extern obj_t BGl_checkzd2sharingzd2zzast_checkzd2sharingzd2(obj_t, obj_t);
extern obj_t BGl_makezd2heapzd2zzheap_makez00();
extern obj_t BGl_za2interpreterza2z00zzengine_paramz00;
static obj_t BGl_zc3anonymousza32765ze3z83zzengine_compilerz00(obj_t);
static obj_t BGl_zc3anonymousza32912ze3z83zzengine_compilerz00(obj_t);
static obj_t BGl_zc3anonymousza33013ze3z83zzengine_compilerz00(obj_t);
extern obj_t BGl_za2restzd2argsza2zd2zzengine_paramz00;
extern obj_t BGl_za2objza2z00zztype_cachez00;
extern obj_t BGl_astzb2initializa7ersz15zzcgen_walkz00(obj_t);
BGL_IMPORT obj_t BGl_warningz00zz__errorz00(obj_t);
static obj_t BGl_zc3anonymousza33020ze3z83zzengine_compilerz00(obj_t);
static obj_t BGl_requirezd2initializa7ationz75zzengine_compilerz00 = BUNSPEC;
extern obj_t BGl_za2modulezd2checksumzd2objectzf3za2zf3zzengine_paramz00;
extern obj_t BGl_callcczd2walkz12zc0zzcallcc_walkz00(obj_t);
extern obj_t BGl_backendzd2walkzd2zzbackend_walkz00(obj_t, obj_t);
BGL_IMPORT obj_t BGl_za2warningza2z00zz__errorz00;
extern obj_t BGl_za2profilezd2modeza2zd2zzengine_paramz00;
BGL_IMPORT bool_t BGl_eqvzf3zf3zz__r4_equivalence_6_2z00(obj_t, obj_t);
static obj_t BGl_zc3anonymousza33028ze3z83zzengine_compilerz00(obj_t);
static obj_t BGl_libraryzd2moduleszd2initz00zzengine_compilerz00();
extern obj_t BGl_readzd2srczd2zzread_srcz00();
static obj_t BGl_zc3anonymousza32929ze3z83zzengine_compilerz00(obj_t);
extern obj_t BGl_exitzd2bigloozd2zzinit_mainz00(obj_t);
extern obj_t BGl_dotnetz00zzdotnet_dotnetz00(obj_t);
static obj_t BGl__compilerz00zzengine_compilerz00(obj_t);
static obj_t __cnst[ 41 ] ;


DEFINE_STRING( BGl_string3709z00zzengine_compilerz00, BgL_bgl_string3709za700za7za7engine_compilerza7003740z00, "done il .net jast jvmas cc jvm c reduce+ effect+ inline+ reducer cnst bdb reduce egen coerce integrate cfa globalize globalization fail trace inline all effect callcc (jvm .net) bdb-spread-obj make-add-heap make-heap ast expand user hgen (pragma::int \"bdb_release_lock()\") *debug* set! (#unspecified) mco dump-heap ", 315 );
DEFINE_STRING( BGl_string3699z00zzengine_compilerz00, BgL_bgl_string3699za700za7za7engine_compilerza7003741z00, "inline+", 7 );
DEFINE_STRING( BGl_string3708z00zzengine_compilerz00, BgL_bgl_string3708za700za7za7engine_compilerza7003742z00, "Unimplemented target language", 29 );
DEFINE_STRING( BGl_string3698z00zzengine_compilerz00, BgL_bgl_string3698za700za7za7engine_compilerza7003743z00, "cnst", 4 );
DEFINE_STRING( BGl_string3707z00zzengine_compilerz00, BgL_bgl_string3707za700za7za7engine_compilerza7003744z00, "compiler", 8 );
DEFINE_STRING( BGl_string3697z00zzengine_compilerz00, BgL_bgl_string3697za700za7za7engine_compilerza7003745z00, "reduce", 6 );
DEFINE_STRING( BGl_string3696z00zzengine_compilerz00, BgL_bgl_string3696za700za7za7engine_compilerza7003746z00, "coerce", 6 );
DEFINE_STRING( BGl_string3695z00zzengine_compilerz00, BgL_bgl_string3695za700za7za7engine_compilerza7003747z00, "integrate", 9 );
DEFINE_STRING( BGl_string3694z00zzengine_compilerz00, BgL_bgl_string3694za700za7za7engine_compilerza7003748z00, "cfa", 3 );
DEFINE_STRING( BGl_string3693z00zzengine_compilerz00, BgL_bgl_string3693za700za7za7engine_compilerza7003749z00, "globalize", 9 );
DEFINE_STRING( BGl_string3692z00zzengine_compilerz00, BgL_bgl_string3692za700za7za7engine_compilerza7003750z00, "fail", 4 );
DEFINE_STRING( BGl_string3701z00zzengine_compilerz00, BgL_bgl_string3701za700za7za7engine_compilerza7003751z00, "reduce+", 7 );
DEFINE_STRING( BGl_string3691z00zzengine_compilerz00, BgL_bgl_string3691za700za7za7engine_compilerza7003752z00, "inline", 6 );
DEFINE_STRING( BGl_string3700z00zzengine_compilerz00, BgL_bgl_string3700za700za7za7engine_compilerza7003753z00, "init", 4 );
DEFINE_STRING( BGl_string3690z00zzengine_compilerz00, BgL_bgl_string3690za700za7za7engine_compilerza7003754z00, "effect", 6 );
DEFINE_STRING( BGl_string3689z00zzengine_compilerz00, BgL_bgl_string3689za700za7za7engine_compilerza7003755z00, "callcc", 6 );
DEFINE_STRING( BGl_string3688z00zzengine_compilerz00, BgL_bgl_string3688za700za7za7engine_compilerza7003756z00, "trace", 5 );
DEFINE_STRING( BGl_string3685z00zzengine_compilerz00, BgL_bgl_string3685za700za7za7engine_compilerza7003757z00, "ast", 3 );
DEFINE_STRING( BGl_string3684z00zzengine_compilerz00, BgL_bgl_string3684za700za7za7engine_compilerza7003758z00, "failure during postlude hook", 28 );
DEFINE_STRING( BGl_string3683z00zzengine_compilerz00, BgL_bgl_string3683za700za7za7engine_compilerza7003759z00, " occured, ending ...", 20 );
DEFINE_STRING( BGl_string3682z00zzengine_compilerz00, BgL_bgl_string3682za700za7za7engine_compilerza7003760z00, " error", 6 );
DEFINE_STRING( BGl_string3679z00zzengine_compilerz00, BgL_bgl_string3679za700za7za7engine_compilerza7003761z00, "Don't know what to do with arguments: ", 38 );
DEFINE_STRING( BGl_string3678z00zzengine_compilerz00, BgL_bgl_string3678za700za7za7engine_compilerza7003762z00, "Illegal source file", 19 );
DEFINE_STRING( BGl_string3677z00zzengine_compilerz00, BgL_bgl_string3677za700za7za7engine_compilerza7003763z00, "Parse error", 11 );
DEFINE_EXPORT_PROCEDURE( BGl_compilerzd2envzd2zzengine_compilerz00, BgL_bgl__compilerza700za7za7engine_compilerza7003764z00, BGl__compilerz00zzengine_compilerz00, 0L, 0 );
extern obj_t BGl_hgenzd2walkzd2envz00zzhgen_walkz00;
DEFINE_STATIC_PROCEDURE( BGl_proc3680z00zzengine_compilerz00, BgL_bgl_za7c3anonymousza7a32752za7e3za783za7za7engine_compilerza7003765za7, BGl_zc3anonymousza32752ze3z83zzengine_compilerz00, 0L, 0 );
DEFINE_STATIC_PROCEDURE( BGl_proc3681z00zzengine_compilerz00, BgL_bgl_za7c3anonymousza7a32765za7e3za783za7za7engine_compilerza7003766za7, BGl_zc3anonymousza32765ze3z83zzengine_compilerz00, 0L, 0 );
DEFINE_STATIC_PROCEDURE( BGl_proc3686z00zzengine_compilerz00, BgL_bgl_za7c3anonymousza7a32864za7e3za783za7za7engine_compilerza7003767za7, BGl_zc3anonymousza32864ze3z83zzengine_compilerz00, 0L, 0 );
DEFINE_STATIC_PROCEDURE( BGl_proc3687z00zzengine_compilerz00, BgL_bgl_za7c3anonymousza7a32871za7e3za783za7za7engine_compilerza7003768za7, BGl_zc3anonymousza32871ze3z83zzengine_compilerz00, 0L, 0 );
DEFINE_STATIC_PROCEDURE( BGl_proc3702z00zzengine_compilerz00, BgL_bgl_za7c3anonymousza7a33060za7e3za783za7za7engine_compilerza7003769za7, BGl_zc3anonymousza33060ze3z83zzengine_compilerz00, 0L, 0 );
DEFINE_STATIC_PROCEDURE( BGl_proc3703z00zzengine_compilerz00, BgL_bgl_za7c3anonymousza7a33065za7e3za783za7za7engine_compilerza7003770za7, BGl_zc3anonymousza33065ze3z83zzengine_compilerz00, 0L, 0 );
DEFINE_STATIC_PROCEDURE( BGl_proc3704z00zzengine_compilerz00, BgL_bgl_za7c3anonymousza7a33070za7e3za783za7za7engine_compilerza7003771za7, BGl_zc3anonymousza33070ze3z83zzengine_compilerz00, 0L, 0 );
DEFINE_STATIC_PROCEDURE( BGl_proc3705z00zzengine_compilerz00, BgL_bgl_za7c3anonymousza7a33078za7e3za783za7za7engine_compilerza7003772za7, BGl_zc3anonymousza33078ze3z83zzengine_compilerz00, 0L, 0 );
DEFINE_STATIC_PROCEDURE( BGl_proc3706z00zzengine_compilerz00, BgL_bgl_za7c3anonymousza7a33083za7e3za783za7za7engine_compilerza7003773za7, BGl_zc3anonymousza33083ze3z83zzengine_compilerz00, 0L, 0 );



/* module-initialization */
BGL_EXPORTED_DEF obj_t BGl_modulezd2initializa7ationz75zzengine_compilerz00(long BgL_checksumz00_1430, char * BgL_fromz00_1431)
{ AN_OBJECT;
{ 
if(
CBOOL(BGl_requirezd2initializa7ationz75zzengine_compilerz00))
{ 
BGl_requirezd2initializa7ationz75zzengine_compilerz00 = 
BBOOL(((bool_t)0)); 
BGl_libraryzd2moduleszd2initz00zzengine_compilerz00(); 
BGl_cnstzd2initzd2zzengine_compilerz00(); 
BGl_importedzd2moduleszd2initz00zzengine_compilerz00(); 
return BUNSPEC;}  else 
{ 
return BUNSPEC;} } 
}



/* library-modules-init */
obj_t BGl_libraryzd2moduleszd2initz00zzengine_compilerz00()
{ AN_OBJECT;
{ /* ./Engine/compiler.scm 15 */
BGl_modulezd2initializa7ationz75zz__r4_numbers_6_5_flonumz00(((long)0), "engine_compiler"); 
BGl_modulezd2initializa7ationz75zz__readerz00(((long)0), "engine_compiler"); 
BGl_modulezd2initializa7ationz75zz__r4_output_6_10_3z00(((long)0), "engine_compiler"); 
BGl_modulezd2initializa7ationz75zz__errorz00(((long)0), "engine_compiler"); 
BGl_modulezd2initializa7ationz75zz__r4_numbers_6_5z00(((long)0), "engine_compiler"); 
BGl_modulezd2initializa7ationz75zz__r4_pairs_and_lists_6_3z00(((long)0), "engine_compiler"); 
BGl_modulezd2initializa7ationz75zz__r4_equivalence_6_2z00(((long)0), "engine_compiler"); 
return BUNSPEC;} 
}



/* cnst-init */
obj_t BGl_cnstzd2initzd2zzengine_compilerz00()
{ AN_OBJECT;
{ /* ./Engine/compiler.scm 15 */
{ /* ./Engine/compiler.scm 15 */
obj_t BgL_cportz00_1423;
BgL_cportz00_1423 = 
open_input_string(BGl_string3709z00zzengine_compilerz00); 
{ 
long BgL_iz00_1424;
BgL_iz00_1424 = ((long)40); 
BgL_loopz00_1425:
{ /* ./Engine/compiler.scm 15 */
bool_t BgL_test3711z00_1426;
BgL_test3711z00_1426 = 
(BgL_iz00_1424==((long)-1)); 
if(BgL_test3711z00_1426)
{ /* ./Engine/compiler.scm 15 */
return BUNSPEC;}  else 
{ /* ./Engine/compiler.scm 15 */
{ /* ./Engine/compiler.scm 15 */
obj_t BgL_arg3713z00_1427;
{ /* ./Engine/compiler.scm 15 */
obj_t BgL_list3716z00_1428;
BgL_list3716z00_1428 = 
MAKE_PAIR(BgL_cportz00_1423, BNIL); 
BgL_arg3713z00_1427 = 
BGl_readz00zz__readerz00(BgL_list3716z00_1428); } 
{ /* ./Engine/compiler.scm 15 */
int BgL_auxz00_1450;
BgL_auxz00_1450 = 
(int)(BgL_iz00_1424); 
CNST_TABLE_SET(BgL_auxz00_1450, BgL_arg3713z00_1427); } } 
{ /* ./Engine/compiler.scm 15 */
int BgL_auxz00_1429;
{ /* ./Engine/compiler.scm 15 */
long BgL_auxz00_1453;
BgL_auxz00_1453 = 
(BgL_iz00_1424-((long)1)); 
BgL_auxz00_1429 = 
(int)(BgL_auxz00_1453); } 
{ 
long BgL_iz00_1456;
BgL_iz00_1456 = 
(long)(BgL_auxz00_1429); 
BgL_iz00_1424 = BgL_iz00_1456; 
goto BgL_loopz00_1425;} } } } } } } 
}



/* toplevel-init */
obj_t BGl_toplevelzd2initzd2zzengine_compilerz00()
{ AN_OBJECT;
{ /* ./Engine/compiler.scm 15 */
return BUNSPEC;} 
}



/* compiler */
BGL_EXPORTED_DEF obj_t BGl_compilerz00zzengine_compilerz00()
{ AN_OBJECT;
{ /* ./Engine/compiler.scm 78 */
BGl_installzd2compilerzd2signalsz12z12zzengine_signalsz00(); 
{ /* ./Engine/compiler.scm 84 */
obj_t BgL_srcz00_696;
BgL_srcz00_696 = 
BGl_readzd2srczd2zzread_srcz00(); 
if(
CBOOL(BgL_srcz00_696))
{ /* ./Engine/compiler.scm 92 */
bool_t BgL_test2720z00_697;
BgL_test2720z00_697 = 
PAIRP(BgL_srcz00_696); 
if(BgL_test2720z00_697)
{ /* ./Engine/compiler.scm 92 */BFALSE; }  else 
{ /* ./Engine/compiler.scm 92 */
BGl_userzd2errorzd2zztools_errorz00(BGl_string3677z00zzengine_compilerz00, BGl_string3678z00zzengine_compilerz00, BgL_srcz00_696, BNIL); } }  else 
{ /* ./Engine/compiler.scm 89 */
BGl_za2interpreterza2z00zzengine_paramz00 = BTRUE; 
{ /* ./Engine/compiler.scm 91 */
obj_t BgL_arg2725z00_699;
BgL_arg2725z00_699 = 
BGl_enginez00zzengine_enginez00(); 
BGl_exitzd2bigloozd2zzinit_mainz00(BgL_arg2725z00_699); } } 
BGl_hellozd2worldzd2zzengine_enginez00(); 
{ /* ./Engine/compiler.scm 99 */
bool_t BgL_test2729z00_700;
{ /* ./Engine/compiler.scm 99 */
long BgL_n1z00_1266;
BgL_n1z00_1266 = 
(long)CINT(BGl_za2bdbzd2debugza2zd2zzengine_paramz00); 
BgL_test2729z00_700 = 
(BgL_n1z00_1266>((long)0)); } 
if(BgL_test2729z00_700)
{ /* ./Engine/compiler.scm 99 */
BGl_bdbzd2settingz12zc0zzbdb_settingz00(); }  else 
{ /* ./Engine/compiler.scm 99 */BFALSE; } } 
{ /* ./Engine/compiler.scm 103 */
bool_t BgL_test2732z00_701;
{ /* ./Engine/compiler.scm 103 */
obj_t BgL_objz00_1268;
BgL_objz00_1268 = BGl_za2restzd2argsza2zd2zzengine_paramz00; 
BgL_test2732z00_701 = 
NULLP(BgL_objz00_1268); } 
if(BgL_test2732z00_701)
{ /* ./Engine/compiler.scm 103 */BFALSE; }  else 
{ /* ./Engine/compiler.scm 104 */
obj_t BgL_list2734z00_702;
{ /* ./Engine/compiler.scm 104 */
obj_t BgL_arg2737z00_704;
BgL_arg2737z00_704 = 
MAKE_PAIR(BGl_za2restzd2argsza2zd2zzengine_paramz00, BNIL); 
BgL_list2734z00_702 = 
MAKE_PAIR(BGl_string3679z00zzengine_compilerz00, BgL_arg2737z00_704); } 
BGl_warningz00zz__errorz00(BgL_list2734z00_702); } } 
BGl_readzd2accesszd2filez00zzread_accessz00(); 
BGl_readzd2jfilezd2zzread_jvmz00(); 
if(
CBOOL(BGl_za2libzd2modeza2zd2zzengine_paramz00))
{ /* ./Engine/compiler.scm 111 */
BGl_initializa7ezd2Genvz12z67zzast_envz00(); 
BGl_initializa7ezd2Tenvz12z67zztype_envz00(); }  else 
{ /* ./Engine/compiler.scm 111 */
BGl_restorezd2heapzd2zzheap_restorez00(); } 
BGl_installzd2typezd2cachez12z12zztype_cachez00(); 
BGl_patchzd2vectorzd2setz12z12zzcfa_tvectorz00(); 
{ /* ./Engine/compiler.scm 127 */
obj_t BgL_modulez00_705;
BgL_modulez00_705 = 
CAR(BgL_srcz00_696); 
{ /* ./Engine/compiler.scm 127 */
obj_t BgL_srczd2codezd2_706;
BgL_srczd2codezd2_706 = 
CDR(BgL_srcz00_696); 
{ /* ./Engine/compiler.scm 128 */
obj_t BgL_unitsz00_707;
{ /* ./Engine/compiler.scm 129 */
obj_t BgL_cellvalz00_1488;
BgL_cellvalz00_1488 = 
BGl_producezd2modulez12zc0zzmodule_modulez00(BgL_modulez00_705); 
BgL_unitsz00_707 = 
MAKE_CELL(BgL_cellvalz00_1488); } 
{ /* ./Engine/compiler.scm 129 */

{ /* ./Engine/compiler.scm 131 */
obj_t BgL_arg2749z00_708;
BgL_arg2749z00_708 = 
CNST_TABLE_REF(((long)0)); 
BGl_stopzd2onzd2passz00zzengine_passz00(BgL_arg2749z00_708, BGl_proc3680z00zzengine_compilerz00); } 
{ /* ./Engine/compiler.scm 134 */
bool_t BgL_test2754z00_712;
{ /* ./Engine/compiler.scm 134 */
long BgL_n1z00_1271;
BgL_n1z00_1271 = 
(long)CINT(BGl_za2profilezd2modeza2zd2zzengine_paramz00); 
BgL_test2754z00_712 = 
(BgL_n1z00_1271>=((long)1)); } 
if(BgL_test2754z00_712)
{ /* ./Engine/compiler.scm 135 */
obj_t BgL_auxz00_1403;
{ /* ./Engine/compiler.scm 135 */
obj_t BgL_arg2756z00_713;
BgL_arg2756z00_713 = 
BGl_makezd2profzd2unitz00zzprof_walkz00(); 
{ /* ./Engine/compiler.scm 135 */
obj_t BgL_auxz00_1496;
BgL_auxz00_1496 = 
CELL_REF(BgL_unitsz00_707); 
BgL_auxz00_1403 = 
MAKE_PAIR(BgL_arg2756z00_713, BgL_auxz00_1496); } } 
CELL_SET(BgL_unitsz00_707, BgL_auxz00_1403); }  else 
{ /* ./Engine/compiler.scm 134 */BFALSE; } } 
if(
CBOOL(BGl_za2modulezd2checksumzd2objectzf3za2zf3zzengine_paramz00))
{ /* ./Engine/compiler.scm 138 */
BGl_modulezd2checksumzd2objectz00zzmodule_modulez00(); }  else 
{ /* ./Engine/compiler.scm 138 */BFALSE; } 
{ /* ./Engine/compiler.scm 140 */
obj_t BgL_arg2762z00_714;
BgL_arg2762z00_714 = 
CNST_TABLE_REF(((long)1)); 
BGl_stopzd2onzd2passz00zzengine_passz00(BgL_arg2762z00_714, BGl_proc3681z00zzengine_compilerz00); } 
{ /* ./Engine/compiler.scm 143 */
obj_t BgL_code0z00_718;
if(
NULLP(BgL_srczd2codezd2_706))
{ /* ./Engine/compiler.scm 143 */
BgL_code0z00_718 = 
CNST_TABLE_REF(((long)2)); }  else 
{ /* ./Engine/compiler.scm 143 */
BgL_code0z00_718 = BgL_srczd2codezd2_706; } 
{ /* ./Engine/compiler.scm 143 */
obj_t BgL_code1z00_719;
{ /* ./Engine/compiler.scm 144 */
bool_t BgL_test2775z00_724;
{ /* ./Engine/compiler.scm 144 */
bool_t BgL_test2788z00_730;
{ /* ./Engine/compiler.scm 144 */
obj_t BgL_objz00_1274;
BgL_objz00_1274 = BGl_za2compilerzd2debugza2zd2zzengine_paramz00; 
BgL_test2788z00_730 = 
INTEGERP(BgL_objz00_1274); } 
if(BgL_test2788z00_730)
{ /* ./Engine/compiler.scm 145 */
long BgL_n1z00_1275;
BgL_n1z00_1275 = 
(long)CINT(BGl_za2compilerzd2debugza2zd2zzengine_paramz00); 
BgL_test2775z00_724 = 
(BgL_n1z00_1275>=((long)2)); }  else 
{ /* ./Engine/compiler.scm 144 */
BgL_test2775z00_724 = ((bool_t)0); } } 
if(BgL_test2775z00_724)
{ /* ./Engine/compiler.scm 146 */
obj_t BgL_arg2777z00_725;
{ /* ./Engine/compiler.scm 146 */
obj_t BgL_arg2780z00_726;obj_t BgL_arg2781z00_727;
BgL_arg2780z00_726 = 
CNST_TABLE_REF(((long)3)); 
{ /* ./Engine/compiler.scm 146 */
obj_t BgL_arg2784z00_728;obj_t BgL_arg2785z00_729;
BgL_arg2784z00_728 = 
CNST_TABLE_REF(((long)4)); 
BgL_arg2785z00_729 = 
MAKE_PAIR(BGl_za2compilerzd2debugza2zd2zzengine_paramz00, BNIL); 
BgL_arg2781z00_727 = 
MAKE_PAIR(BgL_arg2784z00_728, BgL_arg2785z00_729); } 
BgL_arg2777z00_725 = 
MAKE_PAIR(BgL_arg2780z00_726, BgL_arg2781z00_727); } 
BgL_code1z00_719 = 
MAKE_PAIR(BgL_arg2777z00_725, BgL_code0z00_718); }  else 
{ /* ./Engine/compiler.scm 144 */
BgL_code1z00_719 = BgL_code0z00_718; } } 
{ /* ./Engine/compiler.scm 144 */
obj_t BgL_code2z00_720;
{ /* ./Engine/compiler.scm 148 */
bool_t BgL_test2770z00_722;
{ /* ./Engine/compiler.scm 148 */
bool_t BgL_test2772z00_723;
{ /* ./Engine/compiler.scm 148 */
obj_t BgL_objz00_1277;
BgL_objz00_1277 = BGl_za2heapzd2debugza2zd2zzengine_paramz00; 
BgL_test2772z00_723 = 
INTEGERP(BgL_objz00_1277); } 
if(BgL_test2772z00_723)
{ /* ./Engine/compiler.scm 148 */
long BgL_n1z00_1278;
BgL_n1z00_1278 = 
(long)CINT(BGl_za2heapzd2debugza2zd2zzengine_paramz00); 
BgL_test2770z00_722 = 
(BgL_n1z00_1278>=((long)1)); }  else 
{ /* ./Engine/compiler.scm 148 */
BgL_test2770z00_722 = ((bool_t)0); } } 
if(BgL_test2770z00_722)
{ /* ./Engine/compiler.scm 153 */
obj_t BgL_auxz00_1522;
BgL_auxz00_1522 = 
CNST_TABLE_REF(((long)5)); 
BgL_code2z00_720 = 
MAKE_PAIR(BgL_auxz00_1522, BgL_code1z00_719); }  else 
{ /* ./Engine/compiler.scm 148 */
BgL_code2z00_720 = BgL_code1z00_719; } } 
{ /* ./Engine/compiler.scm 148 */

{ /* ./Engine/compiler.scm 155 */
obj_t BgL_arg2767z00_721;
BgL_arg2767z00_721 = 
BGl_getzd2toplevelzd2unitz00zzmodule_includez00(); 
BGl_unitzd2sexpza2zd2addz12zb0zzast_unitz00(BgL_arg2767z00_721, BgL_code2z00_720); } } } } } 
{ /* ./Engine/compiler.scm 158 */
bool_t BgL_test2793z00_733;
{ /* ./Engine/compiler.scm 158 */
long BgL_n1z00_1280;
BgL_n1z00_1280 = 
(long)CINT(BGl_za2nbzd2errorzd2onzd2passza2zd2zztools_errorz00); 
BgL_test2793z00_733 = 
(BgL_n1z00_1280>((long)0)); } 
if(BgL_test2793z00_733)
{ /* ./Engine/compiler.scm 158 */
{ /* ./Engine/compiler.scm 158 */
obj_t BgL_port2682z00_734;
BgL_port2682z00_734 = 
BGL_CURRENT_ERROR_PORT(); 
BGl_displayzd22zd2zz__r4_output_6_10_3z00(BGl_za2nbzd2errorzd2onzd2passza2zd2zztools_errorz00, BgL_port2682z00_734); 
display_string(BGl_string3682z00zzengine_compilerz00, BgL_port2682z00_734); 
{ /* ./Engine/compiler.scm 158 */
char * BgL_arg2797z00_735;
{ /* ./Engine/compiler.scm 158 */
bool_t BgL_test2799z00_736;
{ /* ./Engine/compiler.scm 158 */
bool_t BgL_test2800z00_737;
{ /* ./Engine/compiler.scm 158 */
bool_t BgL_res3475z00_1288;
{ /* ./Engine/compiler.scm 158 */
obj_t BgL_objz00_1282;
BgL_objz00_1282 = BGl_za2nbzd2errorzd2onzd2passza2zd2zztools_errorz00; 
{ /* ./Engine/compiler.scm 158 */
bool_t BgL_test1396z00_1283;
BgL_test1396z00_1283 = 
INTEGERP(BgL_objz00_1282); 
if(BgL_test1396z00_1283)
{ /* ./Engine/compiler.scm 158 */
BgL_res3475z00_1288 = ((bool_t)1); }  else 
{ /* ./Engine/compiler.scm 158 */
bool_t BgL_test1397z00_1284;
BgL_test1397z00_1284 = 
REALP(BgL_objz00_1282); 
if(BgL_test1397z00_1284)
{ /* ./Engine/compiler.scm 158 */
double BgL_arg1399z00_1285;
BgL_arg1399z00_1285 = 
BGl_roundflz00zz__r4_numbers_6_5_flonumz00(
REAL_TO_DOUBLE(BgL_objz00_1282)); 
{ /* ./Engine/compiler.scm 158 */
double BgL_auxz00_1539;
BgL_auxz00_1539 = 
REAL_TO_DOUBLE(BgL_objz00_1282); 
BgL_res3475z00_1288 = 
(BgL_auxz00_1539==BgL_arg1399z00_1285); } }  else 
{ /* ./Engine/compiler.scm 158 */
BgL_res3475z00_1288 = ((bool_t)0); } } } } 
BgL_test2800z00_737 = BgL_res3475z00_1288; } 
if(BgL_test2800z00_737)
{ /* ./Engine/compiler.scm 158 */
BgL_test2799z00_736 = 
BGl_2ze3ze3zz__r4_numbers_6_5z00(BGl_za2nbzd2errorzd2onzd2passza2zd2zztools_errorz00, 
BINT(((long)1))); }  else 
{ /* ./Engine/compiler.scm 158 */
BgL_test2799z00_736 = ((bool_t)0); } } 
if(BgL_test2799z00_736)
{ /* ./Engine/compiler.scm 158 */
BgL_arg2797z00_735 = "s"; }  else 
{ /* ./Engine/compiler.scm 158 */
BgL_arg2797z00_735 = ""; } } 
BGl_displayzd22zd2zz__r4_output_6_10_3z00(
string_to_bstring(BgL_arg2797z00_735), BgL_port2682z00_734); } 
display_string(BGl_string3683z00zzengine_compilerz00, BgL_port2682z00_734); 
WRITE_CHAR(((unsigned char)'\n'), BgL_port2682z00_734); } 
{ /* ./Engine/compiler.scm 158 */
obj_t BgL_list2807z00_738;
{ /* ./Engine/compiler.scm 158 */
obj_t BgL_auxz00_1550;
BgL_auxz00_1550 = 
BINT(((long)-1)); 
BgL_list2807z00_738 = 
MAKE_PAIR(BgL_auxz00_1550, BNIL); } 
BGl_exitz00zz__errorz00(BgL_list2807z00_738); } }  else 
{ 
obj_t BgL_hooksz00_739;obj_t BgL_hnamesz00_740;
{ /* ./Engine/compiler.scm 158 */
obj_t BgL_arg2810z00_742;
BgL_arg2810z00_742 = BNIL; 
BgL_hooksz00_739 = BgL_arg2810z00_742; 
BgL_hnamesz00_740 = BNIL; 
BgL_loopz00_741:
{ /* ./Engine/compiler.scm 158 */
bool_t BgL_test2815z00_745;
BgL_test2815z00_745 = 
NULLP(BgL_hooksz00_739); 
if(BgL_test2815z00_745)
{ /* ./Engine/compiler.scm 158 */BUNSPEC; }  else 
{ /* ./Engine/compiler.scm 158 */
bool_t BgL_test2816z00_746;
{ /* ./Engine/compiler.scm 158 */
obj_t BgL_fun2830z00_751;
BgL_fun2830z00_751 = 
CAR(BgL_hooksz00_739); 
{ /* ./Engine/compiler.scm 158 */
obj_t BgL_auxz00_1557;
BgL_auxz00_1557 = 
PROCEDURE_ENTRY(BgL_fun2830z00_751)(BgL_fun2830z00_751, BEOA); 
BgL_test2816z00_746 = 
CBOOL(BgL_auxz00_1557); } } 
if(BgL_test2816z00_746)
{ /* ./Engine/compiler.scm 158 */
{ /* ./Engine/compiler.scm 158 */
obj_t BgL_arg2818z00_747;obj_t BgL_arg2819z00_748;
BgL_arg2818z00_747 = 
CDR(BgL_hooksz00_739); 
BgL_arg2819z00_748 = 
CDR(BgL_hnamesz00_740); 
{ 
obj_t BgL_hnamesz00_1565;obj_t BgL_hooksz00_1564;
BgL_hooksz00_1564 = BgL_arg2818z00_747; 
BgL_hnamesz00_1565 = BgL_arg2819z00_748; 
BgL_hnamesz00_740 = BgL_hnamesz00_1565; 
BgL_hooksz00_739 = BgL_hooksz00_1564; 
goto BgL_loopz00_741;} } }  else 
{ /* ./Engine/compiler.scm 158 */
{ /* ./Engine/compiler.scm 158 */
obj_t BgL_arg2825z00_750;
BgL_arg2825z00_750 = 
CAR(BgL_hnamesz00_740); 
BGl_internalzd2errorzd2zztools_errorz00(BGl_za2currentzd2passza2zd2zzengine_passz00, BGl_string3684z00zzengine_compilerz00, BgL_arg2825z00_750); } } } } } } } 
BGl_checkzd2typeszd2zztype_envz00(); 
BGl_stopzd2onzd2passz00zzengine_passz00(
CNST_TABLE_REF(((long)6)), BGl_hgenzd2walkzd2envz00zzhgen_walkz00); 
BGl_userzd2walkzd2zzuser_userz00(
CELL_REF(BgL_unitsz00_707)); 
{ /* ./Engine/compiler.scm 168 */
obj_t BgL_arg2838z00_752;
BgL_arg2838z00_752 = 
CNST_TABLE_REF(((long)7)); 
{ /* ./Engine/compiler.scm 168 */
obj_t BgL_zc3anonymousza32841ze3z83_1348;
{ 
int BgL_auxz00_1575;int BgL_auxz00_1573;
BgL_auxz00_1575 = 
(int)(((long)1)); 
BgL_auxz00_1573 = 
(int)(((long)0)); 
BgL_zc3anonymousza32841ze3z83_1348 = 
make_fx_procedure(BGl_zc3anonymousza32841ze3z83zzengine_compilerz00, BgL_auxz00_1573, BgL_auxz00_1575); } 
{ /* ./Engine/compiler.scm 168 */
int BgL_auxz00_1578;
BgL_auxz00_1578 = 
(int)(((long)0)); 
PROCEDURE_SET(BgL_zc3anonymousza32841ze3z83_1348, BgL_auxz00_1578, BgL_unitsz00_707); } 
BGl_stopzd2onzd2passz00zzengine_passz00(BgL_arg2838z00_752, BgL_zc3anonymousza32841ze3z83_1348); } } 
BGl_installzd2initialzd2expanderz00zzexpand_installz00(); 
BGl_loadzd2libraryzd2initz00zzinit_setrcz00(); 
BGl_expandzd2unitszd2zzexpand_epsz00(
CELL_REF(BgL_unitsz00_707)); 
{ /* ./Engine/compiler.scm 180 */
obj_t BgL_arg2847z00_756;
BgL_arg2847z00_756 = 
CNST_TABLE_REF(((long)8)); 
{ /* ./Engine/compiler.scm 180 */
obj_t BgL_zc3anonymousza32850ze3z83_1347;
{ 
int BgL_auxz00_1588;int BgL_auxz00_1586;
BgL_auxz00_1588 = 
(int)(((long)1)); 
BgL_auxz00_1586 = 
(int)(((long)0)); 
BgL_zc3anonymousza32850ze3z83_1347 = 
make_fx_procedure(BGl_zc3anonymousza32850ze3z83zzengine_compilerz00, BgL_auxz00_1586, BgL_auxz00_1588); } 
{ /* ./Engine/compiler.scm 180 */
int BgL_auxz00_1591;
BgL_auxz00_1591 = 
(int)(((long)0)); 
PROCEDURE_SET(BgL_zc3anonymousza32850ze3z83_1347, BgL_auxz00_1591, BgL_unitsz00_707); } 
BGl_stopzd2onzd2passz00zzengine_passz00(BgL_arg2847z00_756, BgL_zc3anonymousza32850ze3z83_1347); } } 
{ /* ./Engine/compiler.scm 183 */
obj_t BgL_astz00_760;
{ /* ./Engine/compiler.scm 183 */
obj_t BgL_cellvalz00_1595;
BgL_cellvalz00_1595 = 
BGl_buildzd2astzd2zzast_buildz00(
CELL_REF(BgL_unitsz00_707)); 
BgL_astz00_760 = 
MAKE_CELL(BgL_cellvalz00_1595); } 
{ /* ./Engine/compiler.scm 184 */
obj_t BgL_arg2853z00_761;
BgL_arg2853z00_761 = 
CNST_TABLE_REF(((long)9)); 
{ /* ./Engine/compiler.scm 184 */
obj_t BgL_zc3anonymousza32856ze3z83_1346;
{ 
int BgL_auxz00_1600;int BgL_auxz00_1598;
BgL_auxz00_1600 = 
(int)(((long)1)); 
BgL_auxz00_1598 = 
(int)(((long)0)); 
BgL_zc3anonymousza32856ze3z83_1346 = 
make_fx_procedure(BGl_zc3anonymousza32856ze3z83zzengine_compilerz00, BgL_auxz00_1598, BgL_auxz00_1600); } 
{ /* ./Engine/compiler.scm 184 */
int BgL_auxz00_1603;
BgL_auxz00_1603 = 
(int)(((long)0)); 
PROCEDURE_SET(BgL_zc3anonymousza32856ze3z83_1346, BgL_auxz00_1603, BgL_astz00_760); } 
BGl_stopzd2onzd2passz00zzengine_passz00(BgL_arg2853z00_761, BgL_zc3anonymousza32856ze3z83_1346); } } 
BGl_checkzd2sharingzd2zzast_checkzd2sharingzd2(BGl_string3685z00zzengine_compilerz00, 
CELL_REF(BgL_astz00_760)); 
if(
CBOOL(BGl_za2warningza2z00zz__errorz00))
{ /* ./Engine/compiler.scm 189 */
BGl_checkzd2globalzd2initializa7ationza7zzast_checkzd2globalzd2initz00(); }  else 
{ /* ./Engine/compiler.scm 189 */BFALSE; } 
{ /* ./Engine/compiler.scm 193 */
obj_t BgL_arg2861z00_765;
BgL_arg2861z00_765 = 
CNST_TABLE_REF(((long)10)); 
BGl_stopzd2onzd2passz00zzengine_passz00(BgL_arg2861z00_765, BGl_proc3686z00zzengine_compilerz00); } 
{ /* ./Engine/compiler.scm 196 */
obj_t BgL_arg2868z00_769;
BgL_arg2868z00_769 = 
CNST_TABLE_REF(((long)11)); 
BGl_stopzd2onzd2passz00zzengine_passz00(BgL_arg2868z00_769, BGl_proc3687z00zzengine_compilerz00); } 
{ /* ./Engine/compiler.scm 199 */
bool_t BgL_test2873z00_773;
{ /* ./Engine/compiler.scm 199 */
long BgL_n1z00_1297;
BgL_n1z00_1297 = 
(long)CINT(BGl_za2bdbzd2debugza2zd2zzengine_paramz00); 
BgL_test2873z00_773 = 
(BgL_n1z00_1297>((long)0)); } 
if(BgL_test2873z00_773)
{ /* ./Engine/compiler.scm 199 */
BGl_bdbzd2spreadzd2objz12z12zzbdb_spreadzd2objzd2(
CELL_REF(BgL_astz00_760)); }  else 
{ /* ./Engine/compiler.scm 199 */BFALSE; } } 
{ /* ./Engine/compiler.scm 201 */
obj_t BgL_arg2877z00_774;
BgL_arg2877z00_774 = 
CNST_TABLE_REF(((long)12)); 
{ /* ./Engine/compiler.scm 201 */
obj_t BgL_zc3anonymousza32880ze3z83_1343;
{ 
int BgL_auxz00_1622;int BgL_auxz00_1620;
BgL_auxz00_1622 = 
(int)(((long)1)); 
BgL_auxz00_1620 = 
(int)(((long)0)); 
BgL_zc3anonymousza32880ze3z83_1343 = 
make_fx_procedure(BGl_zc3anonymousza32880ze3z83zzengine_compilerz00, BgL_auxz00_1620, BgL_auxz00_1622); } 
{ /* ./Engine/compiler.scm 201 */
int BgL_auxz00_1625;
BgL_auxz00_1625 = 
(int)(((long)0)); 
PROCEDURE_SET(BgL_zc3anonymousza32880ze3z83_1343, BgL_auxz00_1625, BgL_astz00_760); } 
BGl_stopzd2onzd2passz00zzengine_passz00(BgL_arg2877z00_774, BgL_zc3anonymousza32880ze3z83_1343); } } 
{ /* ./Engine/compiler.scm 205 */
bool_t BgL_test2882z00_778;
{ /* ./Engine/compiler.scm 205 */
bool_t BgL_test2884z00_779;
{ /* ./Engine/compiler.scm 205 */
obj_t BgL_objz00_1299;
BgL_objz00_1299 = BGl_za2compilerzd2debugza2zd2zzengine_paramz00; 
BgL_test2884z00_779 = 
INTEGERP(BgL_objz00_1299); } 
if(BgL_test2884z00_779)
{ /* ./Engine/compiler.scm 206 */
bool_t BgL_test2885z00_780;
{ /* ./Engine/compiler.scm 206 */
long BgL_n1z00_1300;
BgL_n1z00_1300 = 
(long)CINT(BGl_za2compilerzd2debugza2zd2zzengine_paramz00); 
BgL_test2885z00_780 = 
(BgL_n1z00_1300>((long)1)); } 
if(BgL_test2885z00_780)
{ /* ./Engine/compiler.scm 207 */
bool_t BgL_test2886z00_781;
{ /* ./Engine/compiler.scm 207 */
obj_t BgL_auxz00_1634;
BgL_auxz00_1634 = 
BGl_memqz00zz__r4_pairs_and_lists_6_3z00(BGl_za2targetzd2languageza2zd2zzengine_paramz00, 
CNST_TABLE_REF(((long)13))); 
BgL_test2886z00_781 = 
CBOOL(BgL_auxz00_1634); } 
if(BgL_test2886z00_781)
{ /* ./Engine/compiler.scm 207 */
BgL_test2882z00_778 = ((bool_t)0); }  else 
{ /* ./Engine/compiler.scm 207 */
BgL_test2882z00_778 = ((bool_t)1); } }  else 
{ /* ./Engine/compiler.scm 206 */
BgL_test2882z00_778 = ((bool_t)0); } }  else 
{ /* ./Engine/compiler.scm 205 */
BgL_test2882z00_778 = ((bool_t)0); } } 
if(BgL_test2882z00_778)
{ /* ./Engine/compiler.scm 208 */
obj_t BgL_auxz00_1405;
BgL_auxz00_1405 = 
BGl_tracezd2walkz12zc0zztrace_walkz00(
CELL_REF(BgL_astz00_760)); 
CELL_SET(BgL_astz00_760, BgL_auxz00_1405); }  else 
{ /* ./Engine/compiler.scm 205 */BFALSE; } } 
BGl_checkzd2sharingzd2zzast_checkzd2sharingzd2(BGl_string3688z00zzengine_compilerz00, 
CELL_REF(BgL_astz00_760)); 
if(
CBOOL(BGl_za2callzf2cczf3za2z01zzengine_paramz00))
{ /* ./Engine/compiler.scm 214 */
obj_t BgL_auxz00_1406;
BgL_auxz00_1406 = 
BGl_callcczd2walkz12zc0zzcallcc_walkz00(
CELL_REF(BgL_astz00_760)); 
CELL_SET(BgL_astz00_760, BgL_auxz00_1406); }  else 
{ /* ./Engine/compiler.scm 213 */BFALSE; } 
{ /* ./Engine/compiler.scm 215 */
obj_t BgL_arg2893z00_782;
BgL_arg2893z00_782 = 
CNST_TABLE_REF(((long)14)); 
{ /* ./Engine/compiler.scm 215 */
obj_t BgL_zc3anonymousza32896ze3z83_1342;
{ 
int BgL_auxz00_1648;int BgL_auxz00_1646;
BgL_auxz00_1648 = 
(int)(((long)1)); 
BgL_auxz00_1646 = 
(int)(((long)0)); 
BgL_zc3anonymousza32896ze3z83_1342 = 
make_fx_procedure(BGl_zc3anonymousza32896ze3z83zzengine_compilerz00, BgL_auxz00_1646, BgL_auxz00_1648); } 
{ /* ./Engine/compiler.scm 215 */
int BgL_auxz00_1651;
BgL_auxz00_1651 = 
(int)(((long)0)); 
PROCEDURE_SET(BgL_zc3anonymousza32896ze3z83_1342, BgL_auxz00_1651, BgL_astz00_760); } 
BGl_stopzd2onzd2passz00zzengine_passz00(BgL_arg2893z00_782, BgL_zc3anonymousza32896ze3z83_1342); } } 
BGl_checkzd2sharingzd2zzast_checkzd2sharingzd2(BGl_string3689z00zzengine_compilerz00, 
CELL_REF(BgL_astz00_760)); 
if(
CBOOL(BGl_za2optimzd2unrollzd2loopzf3za2zf3zzengine_paramz00))
{ /* ./Engine/compiler.scm 219 */
{ /* ./Engine/compiler.scm 221 */
obj_t BgL_auxz00_1407;
BgL_auxz00_1407 = 
BGl_effectzd2walkz12zc0zzeffect_walkz00(
CELL_REF(BgL_astz00_760), ((bool_t)0)); 
CELL_SET(BgL_astz00_760, BgL_auxz00_1407); } 
{ /* ./Engine/compiler.scm 222 */
obj_t BgL_arg2901z00_786;
BgL_arg2901z00_786 = 
CNST_TABLE_REF(((long)15)); 
{ /* ./Engine/compiler.scm 222 */
obj_t BgL_zc3anonymousza32904ze3z83_1341;
{ 
int BgL_auxz00_1662;int BgL_auxz00_1660;
BgL_auxz00_1662 = 
(int)(((long)1)); 
BgL_auxz00_1660 = 
(int)(((long)0)); 
BgL_zc3anonymousza32904ze3z83_1341 = 
make_fx_procedure(BGl_zc3anonymousza32904ze3z83zzengine_compilerz00, BgL_auxz00_1660, BgL_auxz00_1662); } 
{ /* ./Engine/compiler.scm 222 */
int BgL_auxz00_1665;
BgL_auxz00_1665 = 
(int)(((long)0)); 
PROCEDURE_SET(BgL_zc3anonymousza32904ze3z83_1341, BgL_auxz00_1665, BgL_astz00_760); } 
BGl_stopzd2onzd2passz00zzengine_passz00(BgL_arg2901z00_786, BgL_zc3anonymousza32904ze3z83_1341); } } }  else 
{ /* ./Engine/compiler.scm 219 */BFALSE; } 
BGl_checkzd2sharingzd2zzast_checkzd2sharingzd2(BGl_string3690z00zzengine_compilerz00, 
CELL_REF(BgL_astz00_760)); 
{ /* ./Engine/compiler.scm 226 */
obj_t BgL_auxz00_1408;
BgL_auxz00_1408 = 
BGl_inlinezd2walkz12zc0zzinline_walkz00(
CELL_REF(BgL_astz00_760), 
CNST_TABLE_REF(((long)16))); 
CELL_SET(BgL_astz00_760, BgL_auxz00_1408); } 
{ /* ./Engine/compiler.scm 227 */
obj_t BgL_arg2909z00_790;
BgL_arg2909z00_790 = 
CNST_TABLE_REF(((long)17)); 
{ /* ./Engine/compiler.scm 227 */
obj_t BgL_zc3anonymousza32912ze3z83_1340;
{ 
int BgL_auxz00_1675;int BgL_auxz00_1673;
BgL_auxz00_1675 = 
(int)(((long)1)); 
BgL_auxz00_1673 = 
(int)(((long)0)); 
BgL_zc3anonymousza32912ze3z83_1340 = 
make_fx_procedure(BGl_zc3anonymousza32912ze3z83zzengine_compilerz00, BgL_auxz00_1673, BgL_auxz00_1675); } 
{ /* ./Engine/compiler.scm 227 */
int BgL_auxz00_1678;
BgL_auxz00_1678 = 
(int)(((long)0)); 
PROCEDURE_SET(BgL_zc3anonymousza32912ze3z83_1340, BgL_auxz00_1678, BgL_astz00_760); } 
BGl_stopzd2onzd2passz00zzengine_passz00(BgL_arg2909z00_790, BgL_zc3anonymousza32912ze3z83_1340); } } 
BGl_checkzd2sharingzd2zzast_checkzd2sharingzd2(BGl_string3691z00zzengine_compilerz00, 
CELL_REF(BgL_astz00_760)); 
{ /* ./Engine/compiler.scm 231 */
bool_t BgL_test2915z00_794;
{ /* ./Engine/compiler.scm 231 */
bool_t BgL_test2917z00_795;
{ /* ./Engine/compiler.scm 231 */
obj_t BgL_objz00_1302;
BgL_objz00_1302 = BGl_za2compilerzd2debugza2zd2zzengine_paramz00; 
BgL_test2917z00_795 = 
INTEGERP(BgL_objz00_1302); } 
if(BgL_test2917z00_795)
{ /* ./Engine/compiler.scm 232 */
bool_t BgL_test2918z00_796;
{ /* ./Engine/compiler.scm 232 */
long BgL_n1z00_1303;
BgL_n1z00_1303 = 
(long)CINT(BGl_za2compilerzd2debugza2zd2zzengine_paramz00); 
BgL_test2918z00_796 = 
(BgL_n1z00_1303>((long)0)); } 
if(BgL_test2918z00_796)
{ /* ./Engine/compiler.scm 233 */
bool_t BgL_test2919z00_797;
{ /* ./Engine/compiler.scm 233 */
long BgL_n1z00_1305;
BgL_n1z00_1305 = 
(long)CINT(BGl_za2compilerzd2debugza2zd2zzengine_paramz00); 
BgL_test2919z00_797 = 
(BgL_n1z00_1305<=((long)1)); } 
if(BgL_test2919z00_797)
{ /* ./Engine/compiler.scm 234 */
bool_t BgL_test2920z00_798;
{ /* ./Engine/compiler.scm 234 */
obj_t BgL_auxz00_1691;
BgL_auxz00_1691 = 
BGl_memqz00zz__r4_pairs_and_lists_6_3z00(BGl_za2targetzd2languageza2zd2zzengine_paramz00, 
CNST_TABLE_REF(((long)13))); 
BgL_test2920z00_798 = 
CBOOL(BgL_auxz00_1691); } 
if(BgL_test2920z00_798)
{ /* ./Engine/compiler.scm 234 */
BgL_test2915z00_794 = ((bool_t)0); }  else 
{ /* ./Engine/compiler.scm 234 */
BgL_test2915z00_794 = ((bool_t)1); } }  else 
{ /* ./Engine/compiler.scm 233 */
BgL_test2915z00_794 = ((bool_t)0); } }  else 
{ /* ./Engine/compiler.scm 232 */
BgL_test2915z00_794 = ((bool_t)0); } }  else 
{ /* ./Engine/compiler.scm 231 */
BgL_test2915z00_794 = ((bool_t)0); } } 
if(BgL_test2915z00_794)
{ /* ./Engine/compiler.scm 235 */
obj_t BgL_auxz00_1409;
BgL_auxz00_1409 = 
BGl_tracezd2walkz12zc0zztrace_walkz00(
CELL_REF(BgL_astz00_760)); 
CELL_SET(BgL_astz00_760, BgL_auxz00_1409); }  else 
{ /* ./Engine/compiler.scm 231 */BFALSE; } } 
{ /* ./Engine/compiler.scm 236 */
obj_t BgL_arg2926z00_799;
BgL_arg2926z00_799 = 
CNST_TABLE_REF(((long)18)); 
{ /* ./Engine/compiler.scm 236 */
obj_t BgL_zc3anonymousza32929ze3z83_1339;
{ 
int BgL_auxz00_1701;int BgL_auxz00_1699;
BgL_auxz00_1701 = 
(int)(((long)1)); 
BgL_auxz00_1699 = 
(int)(((long)0)); 
BgL_zc3anonymousza32929ze3z83_1339 = 
make_fx_procedure(BGl_zc3anonymousza32929ze3z83zzengine_compilerz00, BgL_auxz00_1699, BgL_auxz00_1701); } 
{ /* ./Engine/compiler.scm 236 */
int BgL_auxz00_1704;
BgL_auxz00_1704 = 
(int)(((long)0)); 
PROCEDURE_SET(BgL_zc3anonymousza32929ze3z83_1339, BgL_auxz00_1704, BgL_astz00_760); } 
BGl_stopzd2onzd2passz00zzengine_passz00(BgL_arg2926z00_799, BgL_zc3anonymousza32929ze3z83_1339); } } 
BGl_checkzd2sharingzd2zzast_checkzd2sharingzd2(BGl_string3688z00zzengine_compilerz00, 
CELL_REF(BgL_astz00_760)); 
{ /* ./Engine/compiler.scm 241 */
bool_t BgL_test2932z00_803;
{ /* ./Engine/compiler.scm 241 */
bool_t BgL_test2934z00_804;
{ /* ./Engine/compiler.scm 241 */
obj_t BgL_objz00_1307;
BgL_objz00_1307 = BGl_za2compilerzd2debugza2zd2zzengine_paramz00; 
BgL_test2934z00_804 = 
INTEGERP(BgL_objz00_1307); } 
if(BgL_test2934z00_804)
{ /* ./Engine/compiler.scm 241 */
long BgL_n1z00_1308;
BgL_n1z00_1308 = 
(long)CINT(BGl_za2compilerzd2debugza2zd2zzengine_paramz00); 
BgL_test2932z00_803 = 
(BgL_n1z00_1308>((long)0)); }  else 
{ /* ./Engine/compiler.scm 241 */
BgL_test2932z00_803 = ((bool_t)0); } } 
if(BgL_test2932z00_803)
{ /* ./Engine/compiler.scm 242 */
obj_t BgL_auxz00_1410;
BgL_auxz00_1410 = 
BGl_failzd2walkz12zc0zzfail_walkz00(
CELL_REF(BgL_astz00_760)); 
CELL_SET(BgL_astz00_760, BgL_auxz00_1410); }  else 
{ /* ./Engine/compiler.scm 241 */BFALSE; } } 
{ /* ./Engine/compiler.scm 243 */
obj_t BgL_arg2938z00_805;
BgL_arg2938z00_805 = 
CNST_TABLE_REF(((long)19)); 
{ /* ./Engine/compiler.scm 243 */
obj_t BgL_zc3anonymousza32941ze3z83_1338;
{ 
int BgL_auxz00_1718;int BgL_auxz00_1716;
BgL_auxz00_1718 = 
(int)(((long)1)); 
BgL_auxz00_1716 = 
(int)(((long)0)); 
BgL_zc3anonymousza32941ze3z83_1338 = 
make_fx_procedure(BGl_zc3anonymousza32941ze3z83zzengine_compilerz00, BgL_auxz00_1716, BgL_auxz00_1718); } 
{ /* ./Engine/compiler.scm 243 */
int BgL_auxz00_1721;
BgL_auxz00_1721 = 
(int)(((long)0)); 
PROCEDURE_SET(BgL_zc3anonymousza32941ze3z83_1338, BgL_auxz00_1721, BgL_astz00_760); } 
BGl_stopzd2onzd2passz00zzengine_passz00(BgL_arg2938z00_805, BgL_zc3anonymousza32941ze3z83_1338); } } 
BGl_checkzd2sharingzd2zzast_checkzd2sharingzd2(BGl_string3692z00zzengine_compilerz00, 
CELL_REF(BgL_astz00_760)); 
{ /* ./Engine/compiler.scm 247 */
obj_t BgL_auxz00_1411;
BgL_auxz00_1411 = 
BGl_globaliza7ezd2walkz12z67zzglobaliza7e_walkza7(
CELL_REF(BgL_astz00_760), 
CNST_TABLE_REF(((long)20))); 
CELL_SET(BgL_astz00_760, BgL_auxz00_1411); } 
{ /* ./Engine/compiler.scm 248 */
obj_t BgL_arg2946z00_809;
BgL_arg2946z00_809 = 
CNST_TABLE_REF(((long)21)); 
{ /* ./Engine/compiler.scm 248 */
obj_t BgL_zc3anonymousza32949ze3z83_1337;
{ 
int BgL_auxz00_1731;int BgL_auxz00_1729;
BgL_auxz00_1731 = 
(int)(((long)1)); 
BgL_auxz00_1729 = 
(int)(((long)0)); 
BgL_zc3anonymousza32949ze3z83_1337 = 
make_fx_procedure(BGl_zc3anonymousza32949ze3z83zzengine_compilerz00, BgL_auxz00_1729, BgL_auxz00_1731); } 
{ /* ./Engine/compiler.scm 248 */
int BgL_auxz00_1734;
BgL_auxz00_1734 = 
(int)(((long)0)); 
PROCEDURE_SET(BgL_zc3anonymousza32949ze3z83_1337, BgL_auxz00_1734, BgL_astz00_760); } 
BGl_stopzd2onzd2passz00zzengine_passz00(BgL_arg2946z00_809, BgL_zc3anonymousza32949ze3z83_1337); } } 
BGl_checkzd2sharingzd2zzast_checkzd2sharingzd2(BGl_string3693z00zzengine_compilerz00, 
CELL_REF(BgL_astz00_760)); 
{ /* ./Engine/compiler.scm 252 */
obj_t BgL_auxz00_1412;
BgL_auxz00_1412 = 
BGl_cfazd2walkz12zc0zzcfa_walkz00(
CELL_REF(BgL_astz00_760)); 
CELL_SET(BgL_astz00_760, BgL_auxz00_1412); } 
{ /* ./Engine/compiler.scm 253 */
obj_t BgL_arg2954z00_813;
BgL_arg2954z00_813 = 
CNST_TABLE_REF(((long)22)); 
{ /* ./Engine/compiler.scm 253 */
obj_t BgL_zc3anonymousza32957ze3z83_1336;
{ 
int BgL_auxz00_1743;int BgL_auxz00_1741;
BgL_auxz00_1743 = 
(int)(((long)1)); 
BgL_auxz00_1741 = 
(int)(((long)0)); 
BgL_zc3anonymousza32957ze3z83_1336 = 
make_fx_procedure(BGl_zc3anonymousza32957ze3z83zzengine_compilerz00, BgL_auxz00_1741, BgL_auxz00_1743); } 
{ /* ./Engine/compiler.scm 253 */
int BgL_auxz00_1746;
BgL_auxz00_1746 = 
(int)(((long)0)); 
PROCEDURE_SET(BgL_zc3anonymousza32957ze3z83_1336, BgL_auxz00_1746, BgL_astz00_760); } 
BGl_stopzd2onzd2passz00zzengine_passz00(BgL_arg2954z00_813, BgL_zc3anonymousza32957ze3z83_1336); } } 
BGl_checkzd2sharingzd2zzast_checkzd2sharingzd2(BGl_string3694z00zzengine_compilerz00, 
CELL_REF(BgL_astz00_760)); 
BGl_setzd2defaultzd2typez12z12zztype_cachez00(
(BgL_typez00_bglt)(BGl_za2objza2z00zztype_cachez00)); 
{ /* ./Engine/compiler.scm 261 */
obj_t BgL_auxz00_1413;
BgL_auxz00_1413 = 
BGl_integratezd2walkz12zc0zzintegrate_walkz00(
CELL_REF(BgL_astz00_760)); 
CELL_SET(BgL_astz00_760, BgL_auxz00_1413); } 
{ /* ./Engine/compiler.scm 262 */
obj_t BgL_arg2963z00_817;
BgL_arg2963z00_817 = 
CNST_TABLE_REF(((long)23)); 
{ /* ./Engine/compiler.scm 262 */
obj_t BgL_zc3anonymousza32966ze3z83_1335;
{ 
int BgL_auxz00_1757;int BgL_auxz00_1755;
BgL_auxz00_1757 = 
(int)(((long)1)); 
BgL_auxz00_1755 = 
(int)(((long)0)); 
BgL_zc3anonymousza32966ze3z83_1335 = 
make_fx_procedure(BGl_zc3anonymousza32966ze3z83zzengine_compilerz00, BgL_auxz00_1755, BgL_auxz00_1757); } 
{ /* ./Engine/compiler.scm 262 */
int BgL_auxz00_1760;
BgL_auxz00_1760 = 
(int)(((long)0)); 
PROCEDURE_SET(BgL_zc3anonymousza32966ze3z83_1335, BgL_auxz00_1760, BgL_astz00_760); } 
BGl_stopzd2onzd2passz00zzengine_passz00(BgL_arg2963z00_817, BgL_zc3anonymousza32966ze3z83_1335); } } 
BGl_checkzd2sharingzd2zzast_checkzd2sharingzd2(BGl_string3695z00zzengine_compilerz00, 
CELL_REF(BgL_astz00_760)); 
{ /* ./Engine/compiler.scm 266 */
obj_t BgL_auxz00_1414;
BgL_auxz00_1414 = 
BGl_coercezd2walkz12zc0zzcoerce_walkz00(
CELL_REF(BgL_astz00_760)); 
CELL_SET(BgL_astz00_760, BgL_auxz00_1414); } 
{ /* ./Engine/compiler.scm 267 */
obj_t BgL_arg2971z00_821;
BgL_arg2971z00_821 = 
CNST_TABLE_REF(((long)24)); 
{ /* ./Engine/compiler.scm 267 */
obj_t BgL_zc3anonymousza32975ze3z83_1334;
{ 
int BgL_auxz00_1769;int BgL_auxz00_1767;
BgL_auxz00_1769 = 
(int)(((long)1)); 
BgL_auxz00_1767 = 
(int)(((long)0)); 
BgL_zc3anonymousza32975ze3z83_1334 = 
make_fx_procedure(BGl_zc3anonymousza32975ze3z83zzengine_compilerz00, BgL_auxz00_1767, BgL_auxz00_1769); } 
{ /* ./Engine/compiler.scm 267 */
int BgL_auxz00_1772;
BgL_auxz00_1772 = 
(int)(((long)0)); 
PROCEDURE_SET(BgL_zc3anonymousza32975ze3z83_1334, BgL_auxz00_1772, BgL_astz00_760); } 
BGl_stopzd2onzd2passz00zzengine_passz00(BgL_arg2971z00_821, BgL_zc3anonymousza32975ze3z83_1334); } } 
BGl_checkzd2sharingzd2zzast_checkzd2sharingzd2(BGl_string3696z00zzengine_compilerz00, 
CELL_REF(BgL_astz00_760)); 
{ /* ./Engine/compiler.scm 272 */
bool_t BgL_test2978z00_825;
{ /* ./Engine/compiler.scm 272 */
bool_t BgL_test2992z00_834;
{ /* ./Engine/compiler.scm 272 */
long BgL_n1z00_1310;
BgL_n1z00_1310 = 
(long)CINT(BGl_za2optimza2z00zzengine_paramz00); 
BgL_test2992z00_834 = 
(BgL_n1z00_1310>=((long)1)); } 
if(BgL_test2992z00_834)
{ /* ./Engine/compiler.scm 272 */
BgL_test2978z00_825 = ((bool_t)1); }  else 
{ /* ./Engine/compiler.scm 272 */
obj_t BgL_auxz00_1780;
BgL_auxz00_1780 = 
CNST_TABLE_REF(((long)25)); 
BgL_test2978z00_825 = 
(BGl_za2passza2z00zzengine_paramz00==BgL_auxz00_1780); } } 
if(BgL_test2978z00_825)
{ /* ./Engine/compiler.scm 272 */
{ /* ./Engine/compiler.scm 274 */
obj_t BgL_auxz00_1415;
BgL_auxz00_1415 = 
BGl_effectzd2walkz12zc0zzeffect_walkz00(
CELL_REF(BgL_astz00_760), ((bool_t)1)); 
CELL_SET(BgL_astz00_760, BgL_auxz00_1415); } 
{ /* ./Engine/compiler.scm 275 */
obj_t BgL_arg2981z00_826;
BgL_arg2981z00_826 = 
CNST_TABLE_REF(((long)15)); 
{ /* ./Engine/compiler.scm 275 */
obj_t BgL_zc3anonymousza32984ze3z83_1333;
{ 
int BgL_auxz00_1788;int BgL_auxz00_1786;
BgL_auxz00_1788 = 
(int)(((long)1)); 
BgL_auxz00_1786 = 
(int)(((long)0)); 
BgL_zc3anonymousza32984ze3z83_1333 = 
make_fx_procedure(BGl_zc3anonymousza32984ze3z83zzengine_compilerz00, BgL_auxz00_1786, BgL_auxz00_1788); } 
{ /* ./Engine/compiler.scm 275 */
int BgL_auxz00_1791;
BgL_auxz00_1791 = 
(int)(((long)0)); 
PROCEDURE_SET(BgL_zc3anonymousza32984ze3z83_1333, BgL_auxz00_1791, BgL_astz00_760); } 
BGl_stopzd2onzd2passz00zzengine_passz00(BgL_arg2981z00_826, BgL_zc3anonymousza32984ze3z83_1333); } } 
{ /* ./Engine/compiler.scm 276 */
obj_t BgL_arg2987z00_830;
BgL_arg2987z00_830 = 
CNST_TABLE_REF(((long)25)); 
{ /* ./Engine/compiler.scm 276 */
obj_t BgL_zc3anonymousza32990ze3z83_1332;
{ 
int BgL_auxz00_1798;int BgL_auxz00_1796;
BgL_auxz00_1798 = 
(int)(((long)1)); 
BgL_auxz00_1796 = 
(int)(((long)0)); 
BgL_zc3anonymousza32990ze3z83_1332 = 
make_fx_procedure(BGl_zc3anonymousza32990ze3z83zzengine_compilerz00, BgL_auxz00_1796, BgL_auxz00_1798); } 
{ /* ./Engine/compiler.scm 276 */
int BgL_auxz00_1801;
BgL_auxz00_1801 = 
(int)(((long)0)); 
PROCEDURE_SET(BgL_zc3anonymousza32990ze3z83_1332, BgL_auxz00_1801, BgL_astz00_760); } 
BGl_stopzd2onzd2passz00zzengine_passz00(BgL_arg2987z00_830, BgL_zc3anonymousza32990ze3z83_1332); } } }  else 
{ /* ./Engine/compiler.scm 272 */BFALSE; } } 
BGl_checkzd2sharingzd2zzast_checkzd2sharingzd2(BGl_string3690z00zzengine_compilerz00, 
CELL_REF(BgL_astz00_760)); 
{ /* ./Engine/compiler.scm 280 */
bool_t BgL_test2996z00_835;
{ /* ./Engine/compiler.scm 280 */
long BgL_n1z00_1312;
BgL_n1z00_1312 = 
(long)CINT(BGl_za2optimza2z00zzengine_paramz00); 
BgL_test2996z00_835 = 
(BgL_n1z00_1312>=((long)1)); } 
if(BgL_test2996z00_835)
{ /* ./Engine/compiler.scm 281 */
obj_t BgL_auxz00_1416;
BgL_auxz00_1416 = 
BGl_reducezd2walkz12zc0zzreduce_walkz00(
CELL_REF(BgL_astz00_760)); 
CELL_SET(BgL_astz00_760, BgL_auxz00_1416); }  else 
{ /* ./Engine/compiler.scm 280 */BFALSE; } } 
{ /* ./Engine/compiler.scm 282 */
obj_t BgL_arg3000z00_836;
BgL_arg3000z00_836 = 
CNST_TABLE_REF(((long)26)); 
{ /* ./Engine/compiler.scm 282 */
obj_t BgL_zc3anonymousza33003ze3z83_1331;
{ 
int BgL_auxz00_1813;int BgL_auxz00_1811;
BgL_auxz00_1813 = 
(int)(((long)1)); 
BgL_auxz00_1811 = 
(int)(((long)0)); 
BgL_zc3anonymousza33003ze3z83_1331 = 
make_fx_procedure(BGl_zc3anonymousza33003ze3z83zzengine_compilerz00, BgL_auxz00_1811, BgL_auxz00_1813); } 
{ /* ./Engine/compiler.scm 282 */
int BgL_auxz00_1816;
BgL_auxz00_1816 = 
(int)(((long)0)); 
PROCEDURE_SET(BgL_zc3anonymousza33003ze3z83_1331, BgL_auxz00_1816, BgL_astz00_760); } 
BGl_stopzd2onzd2passz00zzengine_passz00(BgL_arg3000z00_836, BgL_zc3anonymousza33003ze3z83_1331); } } 
BGl_checkzd2sharingzd2zzast_checkzd2sharingzd2(BGl_string3697z00zzengine_compilerz00, 
CELL_REF(BgL_astz00_760)); 
{ /* ./Engine/compiler.scm 286 */
bool_t BgL_test3006z00_840;
{ /* ./Engine/compiler.scm 286 */
long BgL_n1z00_1314;
BgL_n1z00_1314 = 
(long)CINT(BGl_za2bdbzd2debugza2zd2zzengine_paramz00); 
BgL_test3006z00_840 = 
(BgL_n1z00_1314>((long)0)); } 
if(BgL_test3006z00_840)
{ /* ./Engine/compiler.scm 287 */
obj_t BgL_auxz00_1417;
BgL_auxz00_1417 = 
BGl_bdbzd2walkz12zc0zzbdb_walkz00(
CELL_REF(BgL_astz00_760)); 
CELL_SET(BgL_astz00_760, BgL_auxz00_1417); }  else 
{ /* ./Engine/compiler.scm 286 */BFALSE; } } 
{ /* ./Engine/compiler.scm 288 */
obj_t BgL_arg3010z00_841;
BgL_arg3010z00_841 = 
CNST_TABLE_REF(((long)27)); 
{ /* ./Engine/compiler.scm 288 */
obj_t BgL_zc3anonymousza33013ze3z83_1330;
{ 
int BgL_auxz00_1828;int BgL_auxz00_1826;
BgL_auxz00_1828 = 
(int)(((long)1)); 
BgL_auxz00_1826 = 
(int)(((long)0)); 
BgL_zc3anonymousza33013ze3z83_1330 = 
make_fx_procedure(BGl_zc3anonymousza33013ze3z83zzengine_compilerz00, BgL_auxz00_1826, BgL_auxz00_1828); } 
{ /* ./Engine/compiler.scm 288 */
int BgL_auxz00_1831;
BgL_auxz00_1831 = 
(int)(((long)0)); 
PROCEDURE_SET(BgL_zc3anonymousza33013ze3z83_1330, BgL_auxz00_1831, BgL_astz00_760); } 
BGl_stopzd2onzd2passz00zzengine_passz00(BgL_arg3010z00_841, BgL_zc3anonymousza33013ze3z83_1330); } } 
{ /* ./Engine/compiler.scm 291 */
obj_t BgL_auxz00_1418;
BgL_auxz00_1418 = 
BGl_cnstzd2walkz12zc0zzcnst_walkz00(
CELL_REF(BgL_astz00_760)); 
CELL_SET(BgL_astz00_760, BgL_auxz00_1418); } 
{ /* ./Engine/compiler.scm 292 */
obj_t BgL_arg3017z00_845;
BgL_arg3017z00_845 = 
CNST_TABLE_REF(((long)28)); 
{ /* ./Engine/compiler.scm 292 */
obj_t BgL_zc3anonymousza33020ze3z83_1329;
{ 
int BgL_auxz00_1839;int BgL_auxz00_1837;
BgL_auxz00_1839 = 
(int)(((long)1)); 
BgL_auxz00_1837 = 
(int)(((long)0)); 
BgL_zc3anonymousza33020ze3z83_1329 = 
make_fx_procedure(BGl_zc3anonymousza33020ze3z83zzengine_compilerz00, BgL_auxz00_1837, BgL_auxz00_1839); } 
{ /* ./Engine/compiler.scm 292 */
int BgL_auxz00_1842;
BgL_auxz00_1842 = 
(int)(((long)0)); 
PROCEDURE_SET(BgL_zc3anonymousza33020ze3z83_1329, BgL_auxz00_1842, BgL_astz00_760); } 
BGl_stopzd2onzd2passz00zzengine_passz00(BgL_arg3017z00_845, BgL_zc3anonymousza33020ze3z83_1329); } } 
BGl_checkzd2sharingzd2zzast_checkzd2sharingzd2(BGl_string3698z00zzengine_compilerz00, 
CELL_REF(BgL_astz00_760)); 
{ /* ./Engine/compiler.scm 297 */
obj_t BgL_auxz00_1419;
BgL_auxz00_1419 = 
BGl_inlinezd2walkz12zc0zzinline_walkz00(
CELL_REF(BgL_astz00_760), 
CNST_TABLE_REF(((long)29))); 
CELL_SET(BgL_astz00_760, BgL_auxz00_1419); } 
{ /* ./Engine/compiler.scm 298 */
obj_t BgL_arg3025z00_849;
BgL_arg3025z00_849 = 
CNST_TABLE_REF(((long)30)); 
{ /* ./Engine/compiler.scm 298 */
obj_t BgL_zc3anonymousza33028ze3z83_1328;
{ 
int BgL_auxz00_1852;int BgL_auxz00_1850;
BgL_auxz00_1852 = 
(int)(((long)1)); 
BgL_auxz00_1850 = 
(int)(((long)0)); 
BgL_zc3anonymousza33028ze3z83_1328 = 
make_fx_procedure(BGl_zc3anonymousza33028ze3z83zzengine_compilerz00, BgL_auxz00_1850, BgL_auxz00_1852); } 
{ /* ./Engine/compiler.scm 298 */
int BgL_auxz00_1855;
BgL_auxz00_1855 = 
(int)(((long)0)); 
PROCEDURE_SET(BgL_zc3anonymousza33028ze3z83_1328, BgL_auxz00_1855, BgL_astz00_760); } 
BGl_stopzd2onzd2passz00zzengine_passz00(BgL_arg3025z00_849, BgL_zc3anonymousza33028ze3z83_1328); } } 
BGl_checkzd2sharingzd2zzast_checkzd2sharingzd2(BGl_string3699z00zzengine_compilerz00, 
CELL_REF(BgL_astz00_760)); 
{ /* ./Engine/compiler.scm 302 */
obj_t BgL_astz00_853;
{ /* ./Engine/compiler.scm 302 */
obj_t BgL_cellvalz00_1860;
BgL_cellvalz00_1860 = 
BGl_astzb2initializa7ersz15zzcgen_walkz00(
CELL_REF(BgL_astz00_760)); 
BgL_astz00_853 = 
MAKE_CELL(BgL_cellvalz00_1860); } 
BGl_checkzd2sharingzd2zzast_checkzd2sharingzd2(BGl_string3700z00zzengine_compilerz00, 
CELL_REF(BgL_astz00_853)); 
{ /* ./Engine/compiler.scm 306 */
bool_t BgL_test3032z00_854;
{ /* ./Engine/compiler.scm 306 */
bool_t BgL_test3041z00_859;
{ /* ./Engine/compiler.scm 306 */
long BgL_n1z00_1316;
BgL_n1z00_1316 = 
(long)CINT(BGl_za2optimza2z00zzengine_paramz00); 
BgL_test3041z00_859 = 
(BgL_n1z00_1316>=((long)2)); } 
if(BgL_test3041z00_859)
{ /* ./Engine/compiler.scm 306 */
BgL_test3032z00_854 = ((bool_t)1); }  else 
{ /* ./Engine/compiler.scm 307 */
obj_t BgL_auxz00_1866;
BgL_auxz00_1866 = 
BGl_memqz00zz__r4_pairs_and_lists_6_3z00(BGl_za2targetzd2languageza2zd2zzengine_paramz00, 
CNST_TABLE_REF(((long)13))); 
BgL_test3032z00_854 = 
CBOOL(BgL_auxz00_1866); } } 
if(BgL_test3032z00_854)
{ /* ./Engine/compiler.scm 306 */
{ /* ./Engine/compiler.scm 309 */
obj_t BgL_auxz00_1420;
BgL_auxz00_1420 = 
BGl_effectzd2walkz12zc0zzeffect_walkz00(
CELL_REF(BgL_astz00_853), ((bool_t)1)); 
CELL_SET(BgL_astz00_853, BgL_auxz00_1420); } 
{ /* ./Engine/compiler.scm 310 */
obj_t BgL_arg3035z00_855;
BgL_arg3035z00_855 = 
CNST_TABLE_REF(((long)31)); 
{ /* ./Engine/compiler.scm 310 */
obj_t BgL_zc3anonymousza33038ze3z83_1327;
{ 
int BgL_auxz00_1875;int BgL_auxz00_1873;
BgL_auxz00_1875 = 
(int)(((long)1)); 
BgL_auxz00_1873 = 
(int)(((long)0)); 
BgL_zc3anonymousza33038ze3z83_1327 = 
make_fx_procedure(BGl_zc3anonymousza33038ze3z83zzengine_compilerz00, BgL_auxz00_1873, BgL_auxz00_1875); } 
{ /* ./Engine/compiler.scm 310 */
int BgL_auxz00_1878;
BgL_auxz00_1878 = 
(int)(((long)0)); 
PROCEDURE_SET(BgL_zc3anonymousza33038ze3z83_1327, BgL_auxz00_1878, BgL_astz00_853); } 
BGl_stopzd2onzd2passz00zzengine_passz00(BgL_arg3035z00_855, BgL_zc3anonymousza33038ze3z83_1327); } } 
{ /* ./Engine/compiler.scm 311 */
obj_t BgL_auxz00_1421;
BgL_auxz00_1421 = 
BGl_reducezd2walkz12zc0zzreduce_walkz00(
CELL_REF(BgL_astz00_853)); 
CELL_SET(BgL_astz00_853, BgL_auxz00_1421); } }  else 
{ /* ./Engine/compiler.scm 306 */BFALSE; } } 
{ /* ./Engine/compiler.scm 312 */
obj_t BgL_arg3045z00_860;
BgL_arg3045z00_860 = 
CNST_TABLE_REF(((long)32)); 
{ /* ./Engine/compiler.scm 312 */
obj_t BgL_zc3anonymousza33049ze3z83_1326;
{ 
int BgL_auxz00_1886;int BgL_auxz00_1884;
BgL_auxz00_1886 = 
(int)(((long)1)); 
BgL_auxz00_1884 = 
(int)(((long)0)); 
BgL_zc3anonymousza33049ze3z83_1326 = 
make_fx_procedure(BGl_zc3anonymousza33049ze3z83zzengine_compilerz00, BgL_auxz00_1884, BgL_auxz00_1886); } 
{ /* ./Engine/compiler.scm 312 */
int BgL_auxz00_1889;
BgL_auxz00_1889 = 
(int)(((long)0)); 
PROCEDURE_SET(BgL_zc3anonymousza33049ze3z83_1326, BgL_auxz00_1889, BgL_astz00_853); } 
BGl_stopzd2onzd2passz00zzengine_passz00(BgL_arg3045z00_860, BgL_zc3anonymousza33049ze3z83_1326); } } 
BGl_checkzd2sharingzd2zzast_checkzd2sharingzd2(BGl_string3701z00zzengine_compilerz00, 
CELL_REF(BgL_astz00_853)); 
{ /* ./Engine/compiler.scm 315 */
bool_t BgL_test3052z00_864;
if(
CBOOL(BGl_za2sawza2z00zzengine_paramz00))
{ /* ./Engine/compiler.scm 315 */
BgL_test3052z00_864 = ((bool_t)1); }  else 
{ /* ./Engine/compiler.scm 315 */
obj_t BgL_auxz00_1896;
BgL_auxz00_1896 = 
CNST_TABLE_REF(((long)33)); 
BgL_test3052z00_864 = 
(BGl_za2targetzd2languageza2zd2zzengine_paramz00==BgL_auxz00_1896); } 
if(BgL_test3052z00_864)
{ /* ./Engine/compiler.scm 315 */
BGl_backendzd2walkzd2zzbackend_walkz00(BGl_za2targetzd2languageza2zd2zzengine_paramz00, 
CELL_REF(BgL_astz00_853)); }  else 
{ /* ./Engine/compiler.scm 317 */
obj_t BgL_casezd2valuezd2_865;
BgL_casezd2valuezd2_865 = BGl_za2targetzd2languageza2zd2zzengine_paramz00; 
{ /* ./Engine/compiler.scm 318 */
bool_t BgL_test3054z00_866;
BgL_test3054z00_866 = 
BGl_eqvzf3zf3zz__r4_equivalence_6_2z00(BgL_casezd2valuezd2_865, 
CNST_TABLE_REF(((long)34))); 
if(BgL_test3054z00_866)
{ /* ./Engine/compiler.scm 318 */
BGl_jvmzd2dumpzd2zzjvm_jdumpz00(
CELL_REF(BgL_astz00_853)); 
{ /* ./Engine/compiler.scm 321 */
obj_t BgL_arg3057z00_867;
BgL_arg3057z00_867 = 
CNST_TABLE_REF(((long)35)); 
BGl_stopzd2onzd2passz00zzengine_passz00(BgL_arg3057z00_867, BGl_proc3702z00zzengine_compilerz00); } 
{ /* ./Engine/compiler.scm 322 */
obj_t BgL_arg3062z00_871;
BgL_arg3062z00_871 = 
CNST_TABLE_REF(((long)36)); 
BGl_stopzd2onzd2passz00zzengine_passz00(BgL_arg3062z00_871, BGl_proc3703z00zzengine_compilerz00); } 
{ /* ./Engine/compiler.scm 323 */
obj_t BgL_arg3067z00_875;
BgL_arg3067z00_875 = 
CNST_TABLE_REF(((long)37)); 
BGl_stopzd2onzd2passz00zzengine_passz00(BgL_arg3067z00_875, BGl_proc3704z00zzengine_compilerz00); } 
BGl_jvmzd2ldzd2zzjvm_ldz00(); }  else 
{ /* ./Engine/compiler.scm 322 */
bool_t BgL_test3072z00_879;
BgL_test3072z00_879 = 
BGl_eqvzf3zf3zz__r4_equivalence_6_2z00(BgL_casezd2valuezd2_865, 
CNST_TABLE_REF(((long)38))); 
if(BgL_test3072z00_879)
{ /* ./Engine/compiler.scm 322 */
BGl_dotnetz00zzdotnet_dotnetz00(
CELL_REF(BgL_astz00_853)); 
{ /* ./Engine/compiler.scm 328 */
obj_t BgL_arg3075z00_880;
BgL_arg3075z00_880 = 
CNST_TABLE_REF(((long)39)); 
BGl_stopzd2onzd2passz00zzengine_passz00(BgL_arg3075z00_880, BGl_proc3705z00zzengine_compilerz00); } 
{ /* ./Engine/compiler.scm 329 */
obj_t BgL_arg3080z00_884;
BgL_arg3080z00_884 = 
CNST_TABLE_REF(((long)35)); 
BGl_stopzd2onzd2passz00zzengine_passz00(BgL_arg3080z00_884, BGl_proc3706z00zzengine_compilerz00); } 
BGl_dotnetzd2ldzd2zzdotnet_ldz00(); }  else 
{ /* ./Engine/compiler.scm 332 */
obj_t BgL_objectz00_1320;
BgL_objectz00_1320 = BGl_za2targetzd2languageza2zd2zzengine_paramz00; 
FAILURE(BGl_string3707z00zzengine_compilerz00,BGl_string3708z00zzengine_compilerz00,BgL_objectz00_1320);} } } } } } 
return 
BINT(((long)0));} } } } } } } 
}



/* _compiler */
obj_t BGl__compilerz00zzengine_compilerz00(obj_t BgL_envz00_1351)
{ AN_OBJECT;
{ /* ./Engine/compiler.scm 78 */
return 
BGl_compilerz00zzengine_compilerz00();} 
}



/* <anonymous:3070> */
obj_t BGl_zc3anonymousza33070ze3z83zzengine_compilerz00(obj_t BgL_envz00_1352)
{ AN_OBJECT;
{ /* ./Engine/compiler.scm 323 */
{ 

return 
CNST_TABLE_REF(((long)40));} } 
}



/* <anonymous:3065> */
obj_t BGl_zc3anonymousza33065ze3z83zzengine_compilerz00(obj_t BgL_envz00_1353)
{ AN_OBJECT;
{ /* ./Engine/compiler.scm 322 */
{ 

return 
CNST_TABLE_REF(((long)40));} } 
}



/* <anonymous:3060> */
obj_t BGl_zc3anonymousza33060ze3z83zzengine_compilerz00(obj_t BgL_envz00_1354)
{ AN_OBJECT;
{ /* ./Engine/compiler.scm 321 */
{ 

return 
CNST_TABLE_REF(((long)40));} } 
}



/* <anonymous:3083> */
obj_t BGl_zc3anonymousza33083ze3z83zzengine_compilerz00(obj_t BgL_envz00_1355)
{ AN_OBJECT;
{ /* ./Engine/compiler.scm 329 */
{ 

return 
CNST_TABLE_REF(((long)40));} } 
}



/* <anonymous:3078> */
obj_t BGl_zc3anonymousza33078ze3z83zzengine_compilerz00(obj_t BgL_envz00_1356)
{ AN_OBJECT;
{ /* ./Engine/compiler.scm 328 */
{ 

return 
CNST_TABLE_REF(((long)40));} } 
}



/* <anonymous:3049> */
obj_t BGl_zc3anonymousza33049ze3z83zzengine_compilerz00(obj_t BgL_envz00_1357)
{ AN_OBJECT;
{ /* ./Engine/compiler.scm 312 */
{ /* ./Engine/compiler.scm 312 */
obj_t BgL_astz00_1358;
{ /* ./Engine/compiler.scm 312 */
int BgL_auxz00_1929;
BgL_auxz00_1929 = 
(int)(((long)0)); 
BgL_astz00_1358 = 
PROCEDURE_REF(BgL_envz00_1357, BgL_auxz00_1929); } 
{ 

return 
BGl_writezd2astzd2zzwrite_astz00(
CELL_REF(BgL_astz00_1358));} } } 
}



/* <anonymous:3038> */
obj_t BGl_zc3anonymousza33038ze3z83zzengine_compilerz00(obj_t BgL_envz00_1359)
{ AN_OBJECT;
{ /* ./Engine/compiler.scm 310 */
{ /* ./Engine/compiler.scm 310 */
obj_t BgL_astz00_1360;
{ /* ./Engine/compiler.scm 310 */
int BgL_auxz00_1933;
BgL_auxz00_1933 = 
(int)(((long)0)); 
BgL_astz00_1360 = 
PROCEDURE_REF(BgL_envz00_1359, BgL_auxz00_1933); } 
{ 

return 
BGl_writezd2astzd2zzwrite_astz00(
CELL_REF(BgL_astz00_1360));} } } 
}



/* <anonymous:3028> */
obj_t BGl_zc3anonymousza33028ze3z83zzengine_compilerz00(obj_t BgL_envz00_1361)
{ AN_OBJECT;
{ /* ./Engine/compiler.scm 298 */
{ /* ./Engine/compiler.scm 298 */
obj_t BgL_astz00_1362;
{ /* ./Engine/compiler.scm 298 */
int BgL_auxz00_1937;
BgL_auxz00_1937 = 
(int)(((long)0)); 
BgL_astz00_1362 = 
PROCEDURE_REF(BgL_envz00_1361, BgL_auxz00_1937); } 
{ 

return 
BGl_writezd2astzd2zzwrite_astz00(
CELL_REF(BgL_astz00_1362));} } } 
}



/* <anonymous:3020> */
obj_t BGl_zc3anonymousza33020ze3z83zzengine_compilerz00(obj_t BgL_envz00_1363)
{ AN_OBJECT;
{ /* ./Engine/compiler.scm 292 */
{ /* ./Engine/compiler.scm 292 */
obj_t BgL_astz00_1364;
{ /* ./Engine/compiler.scm 292 */
int BgL_auxz00_1941;
BgL_auxz00_1941 = 
(int)(((long)0)); 
BgL_astz00_1364 = 
PROCEDURE_REF(BgL_envz00_1363, BgL_auxz00_1941); } 
{ 

return 
BGl_writezd2astzd2zzwrite_astz00(
CELL_REF(BgL_astz00_1364));} } } 
}



/* <anonymous:3013> */
obj_t BGl_zc3anonymousza33013ze3z83zzengine_compilerz00(obj_t BgL_envz00_1365)
{ AN_OBJECT;
{ /* ./Engine/compiler.scm 288 */
{ /* ./Engine/compiler.scm 288 */
obj_t BgL_astz00_1366;
{ /* ./Engine/compiler.scm 288 */
int BgL_auxz00_1945;
BgL_auxz00_1945 = 
(int)(((long)0)); 
BgL_astz00_1366 = 
PROCEDURE_REF(BgL_envz00_1365, BgL_auxz00_1945); } 
{ 

return 
BGl_writezd2astzd2zzwrite_astz00(
CELL_REF(BgL_astz00_1366));} } } 
}



/* <anonymous:3003> */
obj_t BGl_zc3anonymousza33003ze3z83zzengine_compilerz00(obj_t BgL_envz00_1367)
{ AN_OBJECT;
{ /* ./Engine/compiler.scm 282 */
{ /* ./Engine/compiler.scm 282 */
obj_t BgL_astz00_1368;
{ /* ./Engine/compiler.scm 282 */
int BgL_auxz00_1949;
BgL_auxz00_1949 = 
(int)(((long)0)); 
BgL_astz00_1368 = 
PROCEDURE_REF(BgL_envz00_1367, BgL_auxz00_1949); } 
{ 

return 
BGl_writezd2astzd2zzwrite_astz00(
CELL_REF(BgL_astz00_1368));} } } 
}



/* <anonymous:2990> */
obj_t BGl_zc3anonymousza32990ze3z83zzengine_compilerz00(obj_t BgL_envz00_1369)
{ AN_OBJECT;
{ /* ./Engine/compiler.scm 276 */
{ /* ./Engine/compiler.scm 276 */
obj_t BgL_astz00_1370;
{ /* ./Engine/compiler.scm 276 */
int BgL_auxz00_1953;
BgL_auxz00_1953 = 
(int)(((long)0)); 
BgL_astz00_1370 = 
PROCEDURE_REF(BgL_envz00_1369, BgL_auxz00_1953); } 
{ 

return 
BGl_writezd2effectzd2zzeffect_walkz00(
CELL_REF(BgL_astz00_1370));} } } 
}



/* <anonymous:2984> */
obj_t BGl_zc3anonymousza32984ze3z83zzengine_compilerz00(obj_t BgL_envz00_1371)
{ AN_OBJECT;
{ /* ./Engine/compiler.scm 275 */
{ /* ./Engine/compiler.scm 275 */
obj_t BgL_astz00_1372;
{ /* ./Engine/compiler.scm 275 */
int BgL_auxz00_1957;
BgL_auxz00_1957 = 
(int)(((long)0)); 
BgL_astz00_1372 = 
PROCEDURE_REF(BgL_envz00_1371, BgL_auxz00_1957); } 
{ 

return 
BGl_writezd2astzd2zzwrite_astz00(
CELL_REF(BgL_astz00_1372));} } } 
}



/* <anonymous:2975> */
obj_t BGl_zc3anonymousza32975ze3z83zzengine_compilerz00(obj_t BgL_envz00_1373)
{ AN_OBJECT;
{ /* ./Engine/compiler.scm 267 */
{ /* ./Engine/compiler.scm 267 */
obj_t BgL_astz00_1374;
{ /* ./Engine/compiler.scm 267 */
int BgL_auxz00_1961;
BgL_auxz00_1961 = 
(int)(((long)0)); 
BgL_astz00_1374 = 
PROCEDURE_REF(BgL_envz00_1373, BgL_auxz00_1961); } 
{ 

return 
BGl_writezd2astzd2zzwrite_astz00(
CELL_REF(BgL_astz00_1374));} } } 
}



/* <anonymous:2966> */
obj_t BGl_zc3anonymousza32966ze3z83zzengine_compilerz00(obj_t BgL_envz00_1375)
{ AN_OBJECT;
{ /* ./Engine/compiler.scm 262 */
{ /* ./Engine/compiler.scm 262 */
obj_t BgL_astz00_1376;
{ /* ./Engine/compiler.scm 262 */
int BgL_auxz00_1965;
BgL_auxz00_1965 = 
(int)(((long)0)); 
BgL_astz00_1376 = 
PROCEDURE_REF(BgL_envz00_1375, BgL_auxz00_1965); } 
{ 

return 
BGl_writezd2astzd2zzwrite_astz00(
CELL_REF(BgL_astz00_1376));} } } 
}



/* <anonymous:2957> */
obj_t BGl_zc3anonymousza32957ze3z83zzengine_compilerz00(obj_t BgL_envz00_1377)
{ AN_OBJECT;
{ /* ./Engine/compiler.scm 253 */
{ /* ./Engine/compiler.scm 253 */
obj_t BgL_astz00_1378;
{ /* ./Engine/compiler.scm 253 */
int BgL_auxz00_1969;
BgL_auxz00_1969 = 
(int)(((long)0)); 
BgL_astz00_1378 = 
PROCEDURE_REF(BgL_envz00_1377, BgL_auxz00_1969); } 
{ 

return 
BGl_writezd2astzd2zzwrite_astz00(
CELL_REF(BgL_astz00_1378));} } } 
}



/* <anonymous:2949> */
obj_t BGl_zc3anonymousza32949ze3z83zzengine_compilerz00(obj_t BgL_envz00_1379)
{ AN_OBJECT;
{ /* ./Engine/compiler.scm 248 */
{ /* ./Engine/compiler.scm 248 */
obj_t BgL_astz00_1380;
{ /* ./Engine/compiler.scm 248 */
int BgL_auxz00_1973;
BgL_auxz00_1973 = 
(int)(((long)0)); 
BgL_astz00_1380 = 
PROCEDURE_REF(BgL_envz00_1379, BgL_auxz00_1973); } 
{ 

return 
BGl_writezd2astzd2zzwrite_astz00(
CELL_REF(BgL_astz00_1380));} } } 
}



/* <anonymous:2941> */
obj_t BGl_zc3anonymousza32941ze3z83zzengine_compilerz00(obj_t BgL_envz00_1381)
{ AN_OBJECT;
{ /* ./Engine/compiler.scm 243 */
{ /* ./Engine/compiler.scm 243 */
obj_t BgL_astz00_1382;
{ /* ./Engine/compiler.scm 243 */
int BgL_auxz00_1977;
BgL_auxz00_1977 = 
(int)(((long)0)); 
BgL_astz00_1382 = 
PROCEDURE_REF(BgL_envz00_1381, BgL_auxz00_1977); } 
{ 

return 
BGl_writezd2astzd2zzwrite_astz00(
CELL_REF(BgL_astz00_1382));} } } 
}



/* <anonymous:2929> */
obj_t BGl_zc3anonymousza32929ze3z83zzengine_compilerz00(obj_t BgL_envz00_1383)
{ AN_OBJECT;
{ /* ./Engine/compiler.scm 236 */
{ /* ./Engine/compiler.scm 236 */
obj_t BgL_astz00_1384;
{ /* ./Engine/compiler.scm 236 */
int BgL_auxz00_1981;
BgL_auxz00_1981 = 
(int)(((long)0)); 
BgL_astz00_1384 = 
PROCEDURE_REF(BgL_envz00_1383, BgL_auxz00_1981); } 
{ 

return 
BGl_writezd2astzd2zzwrite_astz00(
CELL_REF(BgL_astz00_1384));} } } 
}



/* <anonymous:2912> */
obj_t BGl_zc3anonymousza32912ze3z83zzengine_compilerz00(obj_t BgL_envz00_1385)
{ AN_OBJECT;
{ /* ./Engine/compiler.scm 227 */
{ /* ./Engine/compiler.scm 227 */
obj_t BgL_astz00_1386;
{ /* ./Engine/compiler.scm 227 */
int BgL_auxz00_1985;
BgL_auxz00_1985 = 
(int)(((long)0)); 
BgL_astz00_1386 = 
PROCEDURE_REF(BgL_envz00_1385, BgL_auxz00_1985); } 
{ 

return 
BGl_writezd2astzd2zzwrite_astz00(
CELL_REF(BgL_astz00_1386));} } } 
}



/* <anonymous:2904> */
obj_t BGl_zc3anonymousza32904ze3z83zzengine_compilerz00(obj_t BgL_envz00_1387)
{ AN_OBJECT;
{ /* ./Engine/compiler.scm 222 */
{ /* ./Engine/compiler.scm 222 */
obj_t BgL_astz00_1388;
{ /* ./Engine/compiler.scm 222 */
int BgL_auxz00_1989;
BgL_auxz00_1989 = 
(int)(((long)0)); 
BgL_astz00_1388 = 
PROCEDURE_REF(BgL_envz00_1387, BgL_auxz00_1989); } 
{ 

return 
BGl_writezd2astzd2zzwrite_astz00(
CELL_REF(BgL_astz00_1388));} } } 
}



/* <anonymous:2896> */
obj_t BGl_zc3anonymousza32896ze3z83zzengine_compilerz00(obj_t BgL_envz00_1389)
{ AN_OBJECT;
{ /* ./Engine/compiler.scm 215 */
{ /* ./Engine/compiler.scm 215 */
obj_t BgL_astz00_1390;
{ /* ./Engine/compiler.scm 215 */
int BgL_auxz00_1993;
BgL_auxz00_1993 = 
(int)(((long)0)); 
BgL_astz00_1390 = 
PROCEDURE_REF(BgL_envz00_1389, BgL_auxz00_1993); } 
{ 

return 
BGl_writezd2astzd2zzwrite_astz00(
CELL_REF(BgL_astz00_1390));} } } 
}



/* <anonymous:2880> */
obj_t BGl_zc3anonymousza32880ze3z83zzengine_compilerz00(obj_t BgL_envz00_1391)
{ AN_OBJECT;
{ /* ./Engine/compiler.scm 201 */
{ /* ./Engine/compiler.scm 201 */
obj_t BgL_astz00_1392;
{ /* ./Engine/compiler.scm 201 */
int BgL_auxz00_1997;
BgL_auxz00_1997 = 
(int)(((long)0)); 
BgL_astz00_1392 = 
PROCEDURE_REF(BgL_envz00_1391, BgL_auxz00_1997); } 
{ 

return 
BGl_writezd2astzd2zzwrite_astz00(
CELL_REF(BgL_astz00_1392));} } } 
}



/* <anonymous:2871> */
obj_t BGl_zc3anonymousza32871ze3z83zzengine_compilerz00(obj_t BgL_envz00_1393)
{ AN_OBJECT;
{ /* ./Engine/compiler.scm 196 */
return 
BGl_makezd2addzd2heapz00zzheap_makez00();} 
}



/* <anonymous:2864> */
obj_t BGl_zc3anonymousza32864ze3z83zzengine_compilerz00(obj_t BgL_envz00_1394)
{ AN_OBJECT;
{ /* ./Engine/compiler.scm 193 */
return 
BGl_makezd2heapzd2zzheap_makez00();} 
}



/* <anonymous:2856> */
obj_t BGl_zc3anonymousza32856ze3z83zzengine_compilerz00(obj_t BgL_envz00_1395)
{ AN_OBJECT;
{ /* ./Engine/compiler.scm 184 */
{ /* ./Engine/compiler.scm 184 */
obj_t BgL_astz00_1396;
{ /* ./Engine/compiler.scm 184 */
int BgL_auxz00_2003;
BgL_auxz00_2003 = 
(int)(((long)0)); 
BgL_astz00_1396 = 
PROCEDURE_REF(BgL_envz00_1395, BgL_auxz00_2003); } 
{ 

return 
BGl_writezd2astzd2zzwrite_astz00(
CELL_REF(BgL_astz00_1396));} } } 
}



/* <anonymous:2850> */
obj_t BGl_zc3anonymousza32850ze3z83zzengine_compilerz00(obj_t BgL_envz00_1397)
{ AN_OBJECT;
{ /* ./Engine/compiler.scm 180 */
{ /* ./Engine/compiler.scm 180 */
obj_t BgL_unitsz00_1398;
{ /* ./Engine/compiler.scm 180 */
int BgL_auxz00_2007;
BgL_auxz00_2007 = 
(int)(((long)0)); 
BgL_unitsz00_1398 = 
PROCEDURE_REF(BgL_envz00_1397, BgL_auxz00_2007); } 
{ 

return 
BGl_writezd2expandedzd2zzwrite_expandedz00(
CELL_REF(BgL_unitsz00_1398));} } } 
}



/* <anonymous:2841> */
obj_t BGl_zc3anonymousza32841ze3z83zzengine_compilerz00(obj_t BgL_envz00_1399)
{ AN_OBJECT;
{ /* ./Engine/compiler.scm 168 */
{ /* ./Engine/compiler.scm 168 */
obj_t BgL_unitsz00_1400;
{ /* ./Engine/compiler.scm 168 */
int BgL_auxz00_2011;
BgL_auxz00_2011 = 
(int)(((long)0)); 
BgL_unitsz00_1400 = 
PROCEDURE_REF(BgL_envz00_1399, BgL_auxz00_2011); } 
{ 

return 
BGl_writezd2expandedzd2zzwrite_expandedz00(
CELL_REF(BgL_unitsz00_1400));} } } 
}



/* <anonymous:2765> */
obj_t BGl_zc3anonymousza32765ze3z83zzengine_compilerz00(obj_t BgL_envz00_1401)
{ AN_OBJECT;
{ /* ./Engine/compiler.scm 140 */
return 
BINT(((long)0));} 
}



/* <anonymous:2752> */
obj_t BGl_zc3anonymousza32752ze3z83zzengine_compilerz00(obj_t BgL_envz00_1402)
{ AN_OBJECT;
{ /* ./Engine/compiler.scm 131 */
return 
BGl_dumpzd2additionalzd2heapsz00zzheap_restorez00();} 
}



/* method-init */
obj_t BGl_methodzd2initzd2zzengine_compilerz00()
{ AN_OBJECT;
{ /* ./Engine/compiler.scm 15 */
return BUNSPEC;} 
}



/* imported-modules-init */
obj_t BGl_importedzd2moduleszd2initz00zzengine_compilerz00()
{ AN_OBJECT;
{ /* ./Engine/compiler.scm 15 */
BGl_modulezd2initializa7ationz75zztools_speekz00(((long)23537), "engine_compiler"); 
BGl_modulezd2initializa7ationz75zztools_errorz00(((long)25566), "engine_compiler"); 
BGl_modulezd2initializa7ationz75zzengine_passz00(((long)10268), "engine_compiler"); 
BGl_modulezd2initializa7ationz75zzengine_signalsz00(((long)49314), "engine_compiler"); 
BGl_modulezd2initializa7ationz75zzengine_paramz00(((long)14260), "engine_compiler"); 
BGl_modulezd2initializa7ationz75zzengine_enginez00(((long)46992), "engine_compiler"); 
BGl_modulezd2initializa7ationz75zzread_srcz00(((long)46676), "engine_compiler"); 
BGl_modulezd2initializa7ationz75zzwrite_expandedz00(((long)47979), "engine_compiler"); 
BGl_modulezd2initializa7ationz75zzwrite_astz00(((long)3027), "engine_compiler"); 
BGl_modulezd2initializa7ationz75zzread_accessz00(((long)2266), "engine_compiler"); 
BGl_modulezd2initializa7ationz75zzread_jvmz00(((long)16338), "engine_compiler"); 
BGl_modulezd2initializa7ationz75zzheap_restorez00(((long)18765), "engine_compiler"); 
BGl_modulezd2initializa7ationz75zzheap_makez00(((long)38589), "engine_compiler"); 
BGl_modulezd2initializa7ationz75zzast_envz00(((long)62031), "engine_compiler"); 
BGl_modulezd2initializa7ationz75zzast_checkzd2sharingzd2(((long)39711), "engine_compiler"); 
BGl_modulezd2initializa7ationz75zztype_typez00(((long)19090), "engine_compiler"); 
BGl_modulezd2initializa7ationz75zzast_varz00(((long)44246), "engine_compiler"); 
BGl_modulezd2initializa7ationz75zzast_nodez00(((long)50868), "engine_compiler"); 
BGl_modulezd2initializa7ationz75zzast_buildz00(((long)17453), "engine_compiler"); 
BGl_modulezd2initializa7ationz75zzast_unitz00(((long)47192), "engine_compiler"); 
BGl_modulezd2initializa7ationz75zzast_checkzd2globalzd2initz00(((long)43075), "engine_compiler"); 
BGl_modulezd2initializa7ationz75zzuser_userz00(((long)28513), "engine_compiler"); 
BGl_modulezd2initializa7ationz75zztype_envz00(((long)25186), "engine_compiler"); 
BGl_modulezd2initializa7ationz75zztype_cachez00(((long)25848), "engine_compiler"); 
BGl_modulezd2initializa7ationz75zzmodule_modulez00(((long)8699), "engine_compiler"); 
BGl_modulezd2initializa7ationz75zzmodule_includez00(((long)1783), "engine_compiler"); 
BGl_modulezd2initializa7ationz75zzexpand_epsz00(((long)17978), "engine_compiler"); 
BGl_modulezd2initializa7ationz75zzexpand_installz00(((long)63390), "engine_compiler"); 
BGl_modulezd2initializa7ationz75zzinit_mainz00(((long)6610), "engine_compiler"); 
BGl_modulezd2initializa7ationz75zzinit_setrcz00(((long)1658), "engine_compiler"); 
BGl_modulezd2initializa7ationz75zztrace_walkz00(((long)47784), "engine_compiler"); 
BGl_modulezd2initializa7ationz75zzinline_walkz00(((long)10614), "engine_compiler"); 
BGl_modulezd2initializa7ationz75zzeffect_walkz00(((long)31481), "engine_compiler"); 
BGl_modulezd2initializa7ationz75zzcallcc_walkz00(((long)61694), "engine_compiler"); 
BGl_modulezd2initializa7ationz75zzfail_walkz00(((long)6090), "engine_compiler"); 
BGl_modulezd2initializa7ationz75zzglobaliza7e_walkza7(((long)59349), "engine_compiler"); 
BGl_modulezd2initializa7ationz75zzcfa_walkz00(((long)30794), "engine_compiler"); 
BGl_modulezd2initializa7ationz75zzcfa_tvectorz00(((long)20474), "engine_compiler"); 
BGl_modulezd2initializa7ationz75zzintegrate_walkz00(((long)15305), "engine_compiler"); 
BGl_modulezd2initializa7ationz75zzcoerce_walkz00(((long)1305), "engine_compiler"); 
BGl_modulezd2initializa7ationz75zzreduce_walkz00(((long)36075), "engine_compiler"); 
BGl_modulezd2initializa7ationz75zzcnst_walkz00(((long)13595), "engine_compiler"); 
BGl_modulezd2initializa7ationz75zzcgen_walkz00(((long)54632), "engine_compiler"); 
BGl_modulezd2initializa7ationz75zzhgen_walkz00(((long)30920), "engine_compiler"); 
BGl_modulezd2initializa7ationz75zzbdb_settingz00(((long)20468), "engine_compiler"); 
BGl_modulezd2initializa7ationz75zzbdb_spreadzd2objzd2(((long)59242), "engine_compiler"); 
BGl_modulezd2initializa7ationz75zzbdb_walkz00(((long)59963), "engine_compiler"); 
BGl_modulezd2initializa7ationz75zzprof_walkz00(((long)40796), "engine_compiler"); 
BGl_modulezd2initializa7ationz75zzcc_indentz00(((long)1912), "engine_compiler"); 
BGl_modulezd2initializa7ationz75zzcc_ccz00(((long)15172), "engine_compiler"); 
BGl_modulezd2initializa7ationz75zzcc_ldz00(((long)36014), "engine_compiler"); 
BGl_modulezd2initializa7ationz75zzbackend_walkz00(((long)43168), "engine_compiler"); 
BGl_modulezd2initializa7ationz75zzjvm_jdumpz00(((long)43692), "engine_compiler"); 
BGl_modulezd2initializa7ationz75zzjvm_ldz00(((long)12620), "engine_compiler"); 
BGl_modulezd2initializa7ationz75zzdotnet_dotnetz00(((long)3361), "engine_compiler"); 
return 
BGl_modulezd2initializa7ationz75zzdotnet_ldz00(((long)13132), "engine_compiler");} 
}

